--- Archivo encriptado con funciones para la consola de comandos

--[[   SOPORTE A COMANDOS

CD [ruta(directorio)]       	Cambia de el path de trabajo
DC..                        	Sale de la carpeta actual de trabajo
LDF or # [chunk(texto)]	    	Ejecuta un comando de luaDEV
DOFILE [ruta(archivo.lua)]  	Ejecuta el archivo espesificado como un chunk de luaDEV
EXIT							Retorna al menu oficial de la psp
REINIT							Reinicia el shell fishell
RECOVERY						Inicia el men de recuperacion de fishell
/ or \							Libera un comando
OPEN							Abre el directorio con el explorador de archivos por defecto
OPEN [ruta(archivo/dir)]		Abre el archivo seleccionado con el explorador
PRINT or $ [string(texto)]		Imprime el texto en la pantalla

]]--

--[[   TAREAS PENDIENTES
EXE [ruta(directorio/archivo)]  ejecuta (con el programa por defecto para dicho archivo) el archivo seleccionado
RUNE [ruta(archivo.pbp)]        ejecuta el archivo eboot seleccionado
DEL [ruta(directorio/archivo)]  borra el archivo seleccionado ([i]modo recursivo) 
RENAME [ruta (directorio/archivo)] + [texto (nuevo nombre)] renombra el archivo seleccionado con el nombre seleccionado
]]--

ID001TC.CMD = {}

ID001TC.CMD.selector = false

function ID001TC.insertComand(id,txt)

ID001TC.CMD.selector = false

txt1 = nil
txt2 = nil
txt3 = nil

if txt == "" then return end

id.path = string.lower(id.path)

txt1 = string.lower(string.explode(txt," ")[1])
txt2 = ID001TC.CMD.analizarTexto(id,string.explode(txt," ")[2])

if txt1 == "/" or txt1 == "\"" then
	id.comand = ""
	ID001TC.println(id,"["..id.path.."] ("..getText("comando liberado",ID001TC)..")")
	return
end

if id.comand == "cd" then ---- comando aislado de CD
	ID001TC.CMD.cd(id,txt); 
	return 
end

if id.comand == "ldf" then ---- comando aislado de LDF	
	ID001TC.CMD.ldf(id,ID001TC.CMD.analizarTexto(id,txt)); 
	return 
end

if id.comand == "dofile" then ---- comando aislado de LDF	
	ID001TC.CMD.dofile(id,txt); 
	return 
end

if txt1 == "cd" then ----- Continuacion del comando CD
	if txt2 ~= nil then txt2 = string.sub(txt,4,string.len(txt)); ID001TC.CMD.cd(id,txt2); return end
	ID001TC.println(id,getText("nueva ruta",ID001TC)..":")
	id.comand = "cd"
	return
end

if txt1 == "cd.." then ----- Continuacion del comando CD..
	if id.path == "ms0:/" or id.path == "ef0:/" then
	
	else
	id.path = files.nofile(id.path)
	end
	id.comand = ""
	ID001TC.println(id,"["..id.path.."]")
	return
end

if txt1 == "ldf" or txt1 == "#" then ----- Continuacion del comando LDF
	if txt2 ~= nil then 
		local chunk = ID001TC.CMD.analizarTexto(id,string.sub(txt,#txt1 + 2,#txt))
		
		if txt1 == "#" then
			ID001TC.CMD.ldf(id,chunk,true)
		else
			ID001TC.CMD.ldf(id,chunk)
		end
		
		return 
	end
	
	ID001TC.println(id,getText("funcion de lua a ejecutar",ID001TC)..":")
	id.comand = "ldf"
	return
end 


if txt1 == "dofile" then ----- Continuacion del comando DOFILE
	if txt2 ~= nil then ID001TC.CMD.dofile(id,string.sub(txt,8,string.len(txt))); return end
	ID001TC.println(id,getText("archivo lua a ejecutar",ID001TC)..":")
	id.comand = "dofile"
	return
end

if txt1 == "open" then	
	
	if txt2 ~= nil then
		--txt2 = ID001TC.CMD.analizarTexto(id,string.sub(txt,#txt1 + 1,#txt))
		ID001TC.CMD.openfile(id,txt2)
		return 
	end
	
	launch.custom(id.path)
	return
end

if txt1 == "exit" then
	system.exit()
	return
end

if txt1 == "reload" or txt1 == "reinit" then
	system.reloadSystem()
	return
end

if txt1 == "recovery" then
	system.dofile("RECOVERY/recovery.lua")
	return
end

if txt1 == "print" or txt1 == "$" then
	local printer = ID001TC.CMD.analizarTexto(id,string.sub(txt,#txt1 + 2,#txt))
	
	if printer == "" or printer == nil then
		return
	end
	
	printer = tostring(printer)
	if printer == nil then
		return
	end
	
	table.remove(id.lineas,#id.lineas)
	ID001TC.println(id,printer)
	return
end

ID001TC.println(id,"["..getText("comando no reconocido",ID001TC).."]")
end

function ID001TC.CMD.cd(id,txt) ---- Ejecucion del comando CD

if txt == "" or txt == ".." then return end

if files.exists(txt) then
	id.path = txt
	ID001TC.println(id,"["..id.path.."]")
	id.comand = ""
else
	if files.exists(id.path..txt) then
		id.path = id.path..txt
		ID001TC.println(id,"["..id.path.."] ")
		id.comand = ""
	else
		if files.exists(id.path.."/"..txt) then
			id.path = id.path.."/"..txt
			ID001TC.println(id,"["..id.path.."] ")
			id.comand = ""
		else
			ID001TC.println(id,"\""..txt.."\" "..getText("no existe",ID001TC))
			ID001TC.println(id,"["..id.path.."] ")
			id.comand = ""
		end
	end
end
end


function ID001TC.CMD.ldf(id,txt,invisible) ---- Ejecucion del comando LDF

	if invisible == true then
		id.comand = ""
	end
	
	if loadstring("function tmp() \n"..txt.."\n end \n return tmp") == nil then 
		ID001TC.println(id,getText("[error ejecucion]",ID001TC).." - COMANDO LUADEV INVALIDO")
		if invisible ~= true then ID001TC.println(id,"["..id.path.."][LDF] ") end
		return 
	end
	
	if pcall(loadstring("function tmp() \n"..txt.."\n end \n return tmp")()) == false then
		ID001TC.println(id,getText("[error ejecucion]",ID001TC).." - ERROR EN LA EJECUCION DEL COMANDO")
		if invisible ~= true then ID001TC.println(id,"["..id.path.."][LDF] ") end
		return 
	end
	
	if invisible == true then
		table.remove(id.lineas,#id.lineas)
		id.comand = ""
		return
	end
	
	ID001TC.println(id,getText("chunk ejecutado",ID001TC))
	ID001TC.println(id,"["..id.path.."][LDF] ")
end


function ID001TC.CMD.dofile(id,txt)

if files.exists(txt) then
	dofile(txt)
else
	if files.exists(id.path.."/"..txt) then
		dofile(id.path.."/"..txt)
	else
		if files.exists(id.path..txt) then
			dofile(id.path..txt)
		else
				ID001TC.println(id,getText("archivo lua no encontrado",ID001TC))
				ID001TC.println(id,"["..id.path.."] ")
				id.comand = ""
		end
	end
end

id.comand = ""
end

function ID001TC.CMD.openfile(id,path)
		
	if string.sub(path,#path,#path) == "/" then
		path = string.sub(path,1,#path - 1)
	end
	
	if string.sub(id.path,#id.path,#id.path) == "/" then
		id.path = string.sub(id.path,1,#id.path - 1)
	end
	
	if files.exists(id.path.."/"..path) then
		launch.explorerFile(id.path.."/"..path)
		ID001TC.println(id,"["..id.path.."] ")
		return
	else
	
		if files.exists(path) then
			launch.explorerFile(path)
			ID001TC.println(id,"["..id.path.."] ")
			return
		end
		
		ID001TC.println(id,getText("archivo no encontrado",ID001TC))
		ID001TC.println(id,"["..id.path.."] ")
	end
end


function ID001TC.CMD.analizarTexto(id,texto)
	if texto == nil then return end
	
	if string.sub(texto,#texto,#texto) ~= " " then
		texto = texto.." \n"
	end
	
	local hereInput = false
	local trozos = string.explode(texto," ")
	
	for i = 1,#trozos do
	
		if string.sub(trozos[i],1,1) == "$" then
			tmp_cmd_var = nil
			local chunk = "tmp_cmd_var = tostring("..string.sub(trozos[i],2,#trozos[i])..")"
			
			if loadstring(chunk) ~= nil then
				loadstring(chunk)()
			end
			
			if tmp_cmd_var == nil or tmp_cmd_var == "nil" then
				trozos[i] = "nil"
			else
				trozos[i] = tostring(tmp_cmd_var)
			end
		end
		
		if trozos[i] == "[selector]" then
		
			if ID001TC.CMD.selector == false then
				local fs = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
			
				if fs == nil then 
					fs = "nil"
				end
			
				trozos[i] = fs
				ID001TC.CMD.selector = fs
			else
				trozos[i] = ID001TC.CMD.selector
			end

		end
	end
	
	return table.concat(trozos," ")
end