--- Visor de imagenes modo FULL SCREEN

function ID005VI.image_center(obj,x,y,w,h)

	if x == nil then x = 0 end
	if y == nil then y = 0 end
	if w == nil then w = 480 end
	if h == nil then h = 272 end
	
	if obj.w > w then obj.x =  x - ((obj.w - w) / 2) else obj.x = (w - obj.w) / 2 end
	if obj.h > h then obj.y =  y - ((obj.h - h) / 2) else obj.y = (h - obj.h) / 2 end

end

function ID005VI.reescaleImage(obj,p)
	if p > 300 then p = 300 end
	if p < 10 then p= 10 end

	local lx = obj.x
	local ly = obj.y
	local lh = obj.h
	local lw = obj.w
	
	local w,h = image.scale(obj.img,p)
	
	
	obj.h = h
	obj.w = w
	
	obj.percent = p
	if h < lh then
		obj.x = obj.x - ((w - lw) / 2)
		obj.y = obj.y - ((h - lh) / 2)
	else
		obj.x = obj.x + ((lw - w) / 2)
		obj.y = obj.y + ((lh - h) / 2)
	end
end

function ID005VI.blit_images(obj)

	if #obj < 1 then return end
	
	for i = #obj,1,-1 do
		if obj[i].x < (0 - obj[i].w) + 5 then obj[i].x = (0 - obj[i].w) + 5 end
		if obj[i].y < (0 - obj[i].h) + 5 then obj[i].y = (0 - obj[i].h) + 5 end
		
		obj[i].img:blit(obj[i].x,obj[i].y)
		
		if app.kernel_scroll_ == true then
			if control.old("up",true) then
				ID005VI.reescaleImage(obj[i],obj[i].percent + 1)
			end
			
			if control.old("down",true) then
				ID005VI.reescaleImage(obj[i],obj[i].percent - 1)
			end
		end
		
		if puntero.isOver(obj[i].x,obj[i].y,obj[i].w,obj[i].h) then
			puntero.overOn("link")
		end
		
		if puntero.isOver(obj[i].x,obj[i].y,obj[i].w,obj[i].h) and control.press("select") and ID005VI.isRageImage == false then
			obj[i].ragex = puntero.x 
			obj[i].ragey = puntero.y
			
			ID005VI.imagePointX = obj[i].x
			ID005VI.imagePointY = obj[i].y
			
			ID005VI.isRageImage = true
		end
		
		if control.relase("select") then
			obj[i].ragex = nil
			obj[i].ragey = nil
			ID005VI.isRageImage = false
		end

		if obj[i].ragex ~= nil then
			if control.old("select") then
			
				local despx = math.abs(puntero.x - obj[i].ragex)	--- pixeles de desplazamiento
				local despy = math.abs(puntero.y - obj[i].ragey)	--- pixeles de desplazamiento
				
				if puntero.x < obj[i].ragex then 
					despx = 0 - despx		
				end

				if puntero.y < obj[i].ragey then 
					despy = 0 - despy	
				end		
				
				obj[i].x = ID005VI.imagePointX + despx
				obj[i].y = ID005VI.imagePointY + despy
				
			end
		end
		
	end

end

function ID005VI.add_image(obj,path)
	local img_ = image.load(path)
	
	local image = {
		img = img_,
		x = 0,
		y = 0,
		w = img_:width(),
		h = img_:height(),
		percent = 100,
	}
	
	table.insert(obj,image)
	ID005VI.image_center(image)
	
	return obj
end

function ID005VI.runFullScreenMode(id)
	ID005VI.blit_images(id.paleta)
end