--[[Aqui se configuran las caracteristicas de la aplicacion]]--

ID008ZPM.cfg_.title = getText("titulo",ID008ZPM)
ID008ZPM.cfg_.multiLoad = false
ID008ZPM.cfg_.title_for_accs = "ZPMP"
ID008ZPM.path = "ms0:/FISHELL/APP/ID008ZPM"
---------------------------------------------------------------
---------------------------------------------------------------

--[[ Carga de recursos GLOBALES ]]--
ID008ZPM.img_bar = image.load(ID008ZPM.path.."/src/menu_bar.png")
ID008ZPM.img_on = image.load(ID008ZPM.path.."/src/on.png")
ID008ZPM.img_off = image.load(ID008ZPM.path.."/src/off.png")
ID008ZPM.img_option = image.load(ID008ZPM.path.."/src/option.png")
system.dofile("ms0:/FISHELL/SRC/DOC/ppmanager.lua")

ID008ZPM.isInstall = false
ID008ZPM.ruta_install = ""

ID008ZPM.installDocs = {
	"vsh.txt",
	"game.txt",
	"pops.txt",
	getText("cancelar")
}

--[[ FUNCIONES BASICAS ]]--

function ID008ZPM.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
	id.document = "vsh.txt"
	id.focus = 0	
	id.plugins = ppmanager.loadPlugins(id.document)
	id.page = 1
	id.totalPages = math.ceil(#id.plugins / 10)
	id.scrollbar = scrollbar.new(sdk.x + sdk.w - 10,sdk.y + 24,sdk.h - 30,id.page,id.totalPages)
	
	if input ~= nil and files.exists(input) == true then 
		ID008ZPM.isInstall = true
		ID008ZPM.ruta_install = input
	end
end

function ID008ZPM.reinit(id,input)
	if input == nil then
		return 
	end
	ID008ZPM.isInstall = true
	ID008ZPM.ruta_install = input
end

function ID008ZPM.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--
	if ID008ZPM.isInstall == true then
		screen.print(sdk.x + 10,sdk.y + 5,getText("donde desea instalar",ID008ZPM)..": "..ID008ZPM.ruta_install,0.5,color.new(20,20,20),color.new(255,255,255,200),"left",sdk.w - 20)
		for i = 1,#ID008ZPM.installDocs do
			local x = sdk.x + 10
			local y = sdk. y + 30 + ((i - 1) * 16)
			
			if puntero.isOver(x - 2,y - 1,100,13) then
				draw.fillrect(x - 2, y - 1,100,13,color.new(180,180,180,130))
				draw.rect(x - 2, y - 1,100,13,color.new(80,80,80))
				puntero.overOn("link")
				if control.press("select") then
					if i == #ID008ZPM.installDocs then
						ID008ZPM.isInstall = false
						controls.read()
					else
						ID008ZPM.isInstall = false
						ID008ZPM.instalar(id,ID008ZPM.installDocs[i])
						controls.read() ---- Aqui se deve instalar dicho plugin
					end
				end
			else
				draw.fillrect(x - 2, y - 1,100,13,color.new(100,100,100,100))
				draw.rect(x - 2, y - 1,100,13,color.new(80,80,80))
			end
			
			screen.print(x,y,ID008ZPM.installDocs[i],0.6,color.new(25,25,25),color.new(255,255,255,180))	
		end
		
		return
	end
	

	if app.kernel_scroll_ == true then
		if controls.press("down") and (id.page + 1) <= id.totalPages then
			id.page = id.page + 1
		end
		
		if controls.press("up") and (id.page - 1) > 0 then
			id.page = id.page - 1
		end
	end
	
	ID008ZPM.img_bar:blit(sdk.x,sdk.y)
	screen.print(sdk.x + 21,sdk.y + 4.5,getText("opciones",ID008ZPM),0.5,color.new(30,30,30),0x0)
	screen.print(sdk.x + 398,sdk.y + 3,"["..id.document.."]",0.5,color.new(30,30,30),color.new(255,255,255,100))
	
	if puntero.isOver(sdk.x + 391,sdk.y + 2,70,14) then
		puntero.overOn("link")
		if control.press("select") or control.press("menu") then
			ID008ZPM.documentPopup(id)
			controls.read()
		end
	end
	
	
	if puntero.isOver(sdk.x + 3,sdk.y,84,18) then
		puntero.overOn("link")
		if control.press("select") or control.press("menu") then
			ID008ZPM.optionsPopup(id)
			controls.read() 
		end
	end
	
	local index = 0
	for i = 1 + ((id.page - 1) * 10),((id.page - 1) * 10) + 10 do
		index = index + 1
		if id.plugins[i] == nil then break end
		if i > (id.page * 10) then break end
		
		local x = sdk.x + 5
		local y = sdk.y + 23 + ((index - 1) * 17)
		
		if id.focus == i and kernel.isPopup == false then id.focus = 0 end
		
		if puntero.isOver(x - 2, y - 2,sdk.w - 5,15) and kernel.isPopup == false and kernel.isOption == false or id.focus == i and kernel.isPopup == true then
			
			puntero.overOn("popup_link")
			
			draw.fillrect(x - 2, y - 2,sdk.w - 5,15,color.new(20,20,20,130))
			draw.rect(x - 2, y - 2,sdk.w - 5,15,color.new(0,0,0,140))
			screen.print(x,y,id.plugins[i].path,0.55,color.new(255,255,255),0x0)
			ID008ZPM.img_option:blend(x + 407,y - 2)
			
			if puntero.isOver(x + 407,y - 2,15,15) then
				puntero.overOn("link")
				if control.press("select") then
					ID008ZPM.makePopup(id,i)
					controls.read()
				end
			end
			
			if control.press("menu") then
				ID008ZPM.makePopup(id,i)
			end
			
			if control.press("select") then
				ppmanager.swich(id.plugins,i)
				id.plugins = ppmanager.save(id.plugins,id.document)
			end
		else
			draw.fillrect(x - 2, y - 2,sdk.w - 5,15,color.new(200,200,200,130))
			draw.rect(x - 2, y - 2,sdk.w - 5,15,color.new(170,170,170,130))
			screen.print(x,y,id.plugins[i].path,0.55,color.new(0,0,0),0x0)
		end
		
		if id.plugins[i].value == "1" then
			ID008ZPM.img_on:blit(x + 425,y - 3)
		else
			ID008ZPM.img_off:blit(x + 425,y - 3)
		end
	end
	
	scrollbar.setVal(id.scrollbar,id.page,id.totalPages)
	scrollbar.draw(id.scrollbar)
	scrollbar.setLocation(id.scrollbar,sdk.x + sdk.w - 10,sdk.y + 24)
end

function ID008ZPM.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--
	
end

function ID008ZPM.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--
	ppmanager.free()
	ID008ZPM.isInstall = false
	ID008ZPM.ruta_install = nil
end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--
function ID008ZPM.makePopup(id,index)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
id.focus = index
local idi = id.this.IDI
if id.plugins[index].value == "1" then
	table.insert(eleme,{ texto = getText("desactivar",ID008ZPM), accion = "ID008ZPM.swich("..idi..","..index..")" , est = true })
else
	table.insert(eleme,{ texto = getText("activar",ID008ZPM) , accion = "ID008ZPM.swich("..idi..","..index..")" , est = true })
end

local unins_chk = "optionpanel.init('"..getText("desea desinstalar el plugin",ID008ZPM).." "..files.nopath(id.plugins[index].path).."?','ID008ZPM.desinstalar("..id.this.IDI..","..index..")')"
local unins_chk_prx = "optionpanel.init('"..getText("desea desinstalar el plugin",ID008ZPM).." "..files.nopath(id.plugins[index].path).."? "..getText("tambien se borrara archivo prx",ID008ZPM)..")','ID008ZPM.desinstalar("..id.this.IDI..","..index..",true)')"

table.insert(eleme,{ texto = getText("editar linea",ID008ZPM) , accion = "" , est = false })
table.insert(eleme,{ texto = getText("renombrar plugin",ID008ZPM) , accion = "" , est = false })
table.insert(eleme,{ texto = getText("desinstalar",ID008ZPM) , accion = unins_chk , est = true })
table.insert(eleme,{ texto = getText("desinstalar y borrar",ID008ZPM) , accion = unins_chk_prx , est = true })
table.insert(eleme,{ texto = getText("mover arruba",ID008ZPM) , accion = "ID008ZPM.move("..idi..","..index..",true)" , est = true })
table.insert(eleme,{ texto = getText("mover abajo",ID008ZPM) , accion = "ID008ZPM.move("..idi..","..index..",false)" , est = true })

popup.setElements(eleme)
popup.activate()
end

function ID008ZPM.documentPopup(id)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
table.insert(eleme,{ texto = "vsh.txt" , accion = "ID008ZPM.changeDocument("..id.this.IDI..",'vsh.txt')" , est = true , accionToClose = true })
table.insert(eleme,{ texto = "game.txt" , accion = "ID008ZPM.changeDocument("..id.this.IDI..",'game.txt')" , est = true , accionToClose = true })
table.insert(eleme,{ texto = "pops.txt" , accion = "ID008ZPM.changeDocument("..id.this.IDI..",'pops.txt')" , est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID008ZPM.optionsPopup(id)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
local uninsallck = "optionpanel.init('Desea desinstalar todos los plugins del archivo "..id.document.."?','ID008ZPM.desinstalarAll("..id.this.IDI..")')"

table.insert(eleme,{ texto = getText("instalar plugin",ID008ZPM) , accion = "ID008ZPM.instalarPRX("..id.this.IDI..")" , est = true , accionToClose = true })
table.insert(eleme,{ texto = getText("refrescar lista",ID008ZPM) , accion = "ID008ZPM.changeDocument("..id.this.IDI..",'"..id.document.."')"  , est = true , accionToClose = true })
table.insert(eleme,{ texto = getText("invertir estados",ID008ZPM) , accion = "ID008ZPM.alternar("..id.this.IDI..")" , est = true , accionToClose = true })
table.insert(eleme,{ texto = getText("desinstalar todos",ID008ZPM) , accion = uninsallck , est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID008ZPM.changeDocument(id,document)
	id.document = document
	id.focus = 0	
	id.plugins = ppmanager.loadPlugins(id.document)
	id.page = 1
	id.totalPages = math.ceil(#id.plugins / 10)
	id.scrollbar = scrollbar.new(sdk.x + sdk.w - 10,sdk.y + 24,sdk.h - 30,id.page,id.totalPages)
end

function ID008ZPM.desinstalar(id,index,borrarprx)
	system.printLabel("03",getText("Desinstalando",ID008ZPM))
	local path = id.plugins[index].path
	
	ppmanager.uninstal(id.plugins,index)
	id.plugins = ppmanager.save(id.plugins,id.document)
	
	id.totalPages = math.ceil(#id.plugins / 10)
	if id.page > id.totalPages then
		id.page = id.totalPages
	end
	
	system.closeLabel()
	
	if borrarprx == nil then return end
	if files.exists(path) == false then return end
	
	system.printLabel("03",getText("Borrando prx",ID008ZPM))
	files.remove(path,true)
	system.closeLabel()
end

function ID008ZPM.desinstalarAll(id)
	system.printLabel("03",getText("Desinstalando",ID008ZPM))
	id.plugins = ppmanager.save({},id.document)
	system.closeLabel()
end

function ID008ZPM.swich(id,index)
	ppmanager.swich(id.plugins,index)
	id.plugins = ppmanager.save(id.plugins,id.document)
end

function ID008ZPM.move(id,index,modo)
	if modo == true then
		ppmanager.moveUp(id.plugins,index)
		id.plugins = ppmanager.save(id.plugins,id.document)		
	end
	
	if modo == false then
		ppmanager.moveDown(id.plugins,index)
		id.plugins = ppmanager.save(id.plugins,id.document)
	end
end

function ID008ZPM.alternar(id)
	for i = 1,#id.plugins do
		ppmanager.swich(id.plugins,i)
	end
	
	id.plugins = ppmanager.save(id.plugins,id.document)	
end

function ID008ZPM.instalar(id,documento)
	system.printLabel("03",getText("instalando prx",ID008ZPM))
	
	ID008ZPM.changeDocument(id,documento)
	
	id.plugins = ppmanager.install(id.plugins,ID008ZPM.ruta_install,"1",documento)
	
	id.totalPages = math.ceil(#id.plugins / 10)
	id.page = id.totalPages
	system.closeLabel()
end

function ID008ZPM.instalarPRX(id)
	FILE_SELECTOR_TYPE = "files"					--- Solo se permiten archivos
	FILE_SELECTOR_FILTER = { "prx" }				--- Filtro de archivos prx
	FILE_SELECTOR_NAME_FILTER = "Plugins .PRX"		--- Nombre del filtro
	FILE_SELECTOR_INIT_PATH = "ms0:/seplugins"		--- Current directory (directorio de inicio)
	FILE_SELECTOR_MULTIPLE_INTERVAL = true			--- Permite seleccionar multibles archivos
	
    local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil then
		return
	end
	
	if type(ruta) == "table" then
		for i = 1,#ruta do
			system.printLabel("03",getText("instalando prx",ID008ZPM))
			id.plugins = ppmanager.install(id.plugins,ruta[i],"1",id.document)
			system.closeLabel()
		end
	else
		system.printLabel("03",getText("instalando prx",ID008ZPM))
		id.plugins = ppmanager.install(id.plugins,ruta,"1",id.document)
		system.closeLabel()
	end
	

end

