---[[ FISHELL MAPS Authors: zerozelta | nekerafa | xerpi ]]--

-- Port de PSPMaps para fishell "FISHMAPS"
-- Nota: Atores originales del codigo: xerpi y nekerafa 

ID011FM.cfg_.title = "FISH-MAPS [offline]"
ID011FM.cfg_.title_for_accs = "fish-maps"
ID011FM.cfg_.multiLoad = true
ID011FM.path = "ms0:/FISHELL/APP/ID011FM"
---------------------------------------------------------------
---------------------------------------------------------------

--- Inicializando variables GLOBALES

ID011FM.xml = {} --Tabla para leer archivos xml
ID011FM.update =  {} -- Funciones de actualizacin del mapa

ID011FM.isConnected = false 		--- Variable que define si estas conectado online o no

ID011FM.zoom = {
200,
180,
150,
100,
50,
10,
5,
2,
1,
0.64,
0.32,
0.16,
0.08,
0.04,
0.02,
0.01,
0.005,
0.002,
0.001,
0.0005,
}

--[[ FUNCIONES BASICAS ]]--

function ID011FM.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--

	-- Iniciando variables internas de ID
	
	sdk.loadScreenToConnect() --- Cargamos el panel de conexion en caso de no estar conectado a internet
	
	id.map = { -- Iniciando tabla de los datos [En el id de ventana correspondiente]
		search = "Spain", -- Ultima busqueda
		location = {}, -- Ubicacin: lat (Latitud) y lng (Longitud)
		zoomdate = 4,
		maptype = { "roadmap", "satellite", "terrain", "hybrid", current = 4 },
		mapspanishtype = { "Relevo", "Satlite", "Terreno", "Hbrido" },
		showinfo = true
	}
	
end

function ID011FM.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--
	
	if ID011FM.isConnected == false or id.map.img == nil then
		if sdk.blitScreenToConnect(ID011FM.initialize,id) == true then
		
		else
			return
		end
	end
	
	id.map.img:blit(sdk.x,sdk.y)
	ID011FM.zoom(id)
	ID011FM.move(id)
	
end

function ID011FM.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID011FM.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID011FM.initialize(id)
	ID011FM.update.xml(id)	-- Actualizamos documento xml
	ID011FM.update.http(id) -- Descargamos el mapa
end

function ID011FM.xml.readtag(text, tag) -- xml.readtag(texto, nombre del tag): Devuelve lo que contiene el tag xml
	return string.sub(text, string.find(text, "<"..tag..">")+2+#tag, string.find(text, "</"..tag..">")-1) or ""
end

function ID011FM.xml.read(file, tag, head) -- , isnumber) -- xml.read(texto, tag, tag raiz): Devuelve lo que contiene el tag dentro de un tag xml
	local xmlfile = io.open(file, "r+"); local xmltext = xmlfile:read("*a"); xmlfile:close(); xmlfile = nil
	if head then return ID011FM.xml.readtag(ID011FM.xml.readtag(xmltext, head),tag)
	else return ID011FM.xml.readtag(xmltext, tag) end
end

function ID011FM.isConect()
	if http.get("http://maps.google.com/maps/api/geocode/xml?address="..string.gsub(string.lower(id.map.search), "%s", "+").."&sensor=false","coord.txt") == nil then
		return false
	end
	
	return true
end


	-- ## Funciones generales ## --

	-- Funcin para actualizar la imagen del mapa via http
	function ID011FM.update.http(id)
		http.get("http://maps.google.com/maps/api/staticmap?center="..id.map.location.lat..","..id.map.location.lng.."&format=gif&maptype="..id.map.maptype[id.map.maptype.current].."&zoom="..id.map.zoomdate.."&size=480x300&sensor=true",ID011FM.path.."/src/map.gif")
		if id.map.img then id.map.img:free() end
		id.map.img = image.load(ID011FM.path.."/src/map.gif")
		id.map.img:center()
		files.remove(ID011FM.path.."/src/map.gif")
	end

	-- Funcin para actualizar el archivo xml
	function ID011FM.update.xml(id)
		http.get("http://maps.google.com/maps/api/geocode/xml?address="..string.gsub(string.lower(id.map.search), "%s", "+").."&sensor=false","coord.txt")
		id.map.location.lat = tonumber(ID011FM.xml.read(ID011FM.path.."/coord.txt", "lat","location"))
		id.map.location.lng = tonumber(ID011FM.xml.read(ID011FM.path.."/coord.txt", "lng","location"))
		files.remove(ID011FM.path.."/src/coord.txt")
	end

	-- Funcin para cambiar los valores de las tablas
	function ID011FM.change(tab, dif, id)
		tab.current = tab.current + dif
		if tab.current < 1 then tab.current = #tab end
		if tab.current > #tab then tab.current = 1 end
	end

	-- Funcin para hacer zoom en el mapa
	function ID011FM.zoom(id)
		if control.press("r") then
			id.map.zoomdate = math.min(20,map.zoomdate+2)
			ID011FM.update.http(id)
		elseif control.press("l") then 
			id.map.zoomdate = math.max(1,map.zoomdate-2)
			ID011FM.update.http(id)
		end
	end

	-- Funcin para mover el mapa
		function ID011FM.move(id)
			if app.kernel_scroll_ ~= true then return end
			
			if controls.press("up") then
				id.map.location.lat = id.map.location.lat + ID011FM.zoom[id.map.zoomdate]/4
				update.http(id)
			elseif controls.press("right") then 
				id.map.location.lng = id.map.location.lng + ID011FM.zoom[id.map.zoomdate]/4
				update.http(id)
			elseif controls.press("left") then 
				id.map.location.lng = id.map.location.lng - ID011FM.zoom[id.map.zoomdate]/4
				update.http(id)
			elseif controls.press("down") then 
				id.map.location.lat = id.map.location.lat - ID011FM.zoom[id.map.zoomdate]/4
				update.http(id)
			end
		end
		
	-- Funcin para buscar
		function ID011FM.searchplace(id)
			if controls.press("cross") then
				id.map.search = nkeyboard.osk(id.map.search or "", "City, State", 39)
				id.map.zoomdate = 4
				id.map.update.xml(id)
				id.map.update.http(id)
			end
		end
		
	-- Funcin para hacer captura de pantalla
		function ID011FM.makescreenshot(id)
			local psp = "ms0:/"
			
			if not files.exists(psp.."PICTURE") then files.mkdir(psp.."PICTURE") end
			if not files.exists(psp.."PICTURE/PSPMaps") then files.mkdir(psp.."PICTURE/PSPMaps") end
			local count = 1
			while true do	
				if not files.exists(psp.."PICTURE/PSPMaps/"..id.map.search..count..".png") then break end
				count = count +1			
			end
			local img = image.create(480,272)
			img:blit(0,0,id.map.img)
			img:save(psp.."PICTURE/PSPMaps/"..id.map.search..count..".png")
			img:free()
		end
	
	-------------------------------------