--- LHMADHOCSENDLIB.lua Lua  | HM Adhoc Sender lib | @zerozelta
--- Libreria para envios de archivos via adhoc
--- Esta libreria no incluyeinterfaz grafica

--- NOTA: Solo compatible con luaHM 

--[[ 
				Modo de uso: 


]]--

System.currentDirectory("ms0:")

asl = {}
asl.user = {}
asl.user.name = tostring(System.nickName())
asl.user.mac_adress = tostring(Adhoc.getMac())
asl.user.profile = "0"
asl.adhoc_state = 0
 
function asl.initAdhoc() --- inicia el adhoc [ 1 | 0]
	if pcall(Adhoc.init) == false then  
		return 0		--- Error al conectar adhoc
	end
	
	return 1			--- Adhoc conectado correctamente
end

function asl.connect()		--- inicia coneccion adhoc
	asl.adhoc_state = 0
	
	Adhoc.connect()  				-- Conexin del Adhoc.
	System.sleep(300)
	
	while asl.adhoc_state ~= 1 do
		asl.adhoc_state = Adhoc.getState()
		System.sleep(50)
	end
	
	return 1
end

function asl.resive(wait_time)	-- Esperamos hasta resivir un mensaje via adhoc
	
	if asl.adhoc_state == 0 then return 0 end
	
	local result = ""			
	
	while result == "" do
		asl.adhoc_state = Adhoc.getState()
		
		if asl.adhoc_state ~= 1 then 
			result = 0
			break
		end
		
		Adhoc.send("ping") 	
		result = Adhoc.recv()
		PAD = Controls.read()
		
		if wait_time ~= nil and wait_time > 0 then
			System.sleep(wait_time)
		end
		
	end
	
	local pong = ""
	
	while pong ~= "pong" do
		asl.adhoc_state = Adhoc.getState()
		
		if asl.adhoc_state ~= 1 then 
			break
		end
		
		Adhoc.send("pong") 	
		pong = Adhoc.recv()
		PAD = Controls.read()
		
		if wait_time ~= nil and wait_time > 0 then
			System.sleep(wait_time)
		end
		
	end
	
	
	
	return result
end

function asl.send(Text,wait_time) -- Esperamos hasta enviar un mensaje via adhoc
	if asl.adhoc_state == 0 then return 0 end
	
	local ping = ""
	local status = 1
	
	while ping == "" do
		asl.adhoc_state = Adhoc.getState()
		
		if asl.adhoc_state ~= 1 then 
			status = 0
			break
		end
		
		ping = Adhoc.recv()
		
		if ping ~= "ping" then
			ping = ""
		end
		
		if wait_time ~= nil and wait_time > 0 then
			System.sleep(wait_time)
		end
	end
	
	Adhoc.send(Text)
	
	local pong = ""
	
		while pong ~= "pong" do
		asl.adhoc_state = Adhoc.getState()
		
		if asl.adhoc_state ~= 1 then 
			break
		end
		 
		Adhoc.send("pong") 	
		pong = Adhoc.recv()
		PAD = Controls.read()
		
		if wait_time ~= nil and wait_time > 0 then
			System.sleep(wait_time)
		end
		
	end
	
	return status
end

function asl.mkprofile(tipo)
	if tipo == "sender" then
		asl.user.profile = "PSP1"
	else
		asl.user.profile = "PSP2"
	end
	
	asl.isConected = true
	
	return 1
end

function asl.sendFile(ruta,func) 	--- Funcion principal del envio (Requiere coneccion previa)
	asl.adhoc_state = Adhoc.getState()
	
	if asl.adhoc_state == 0 then return 0 end
	if asl.isConected == false then return 1 end
	if asl.user.profile ~= "PSP1" then return 2 end
	if System.doesDirExist(ruta) == 0 then return 3 end
	
	--Adhoc.send("[CD]ms0:/FISHELL:ms0:/blabla:") 				--- Enviamos el nombre del archivo
	
	while pong == nil do
		pong = Adhoc.recv()			--- Esperamos resupesta del Destinatario (PSP1)
	end
	
	if pong == "no" then
		return false				--- Si se cancelo el envio devuelve false
	end

	-------------- > aqui va el cuerpo principal del envio
	
end

function asl.catchFile(ruta_destino,func)
	asl.adhoc_state = Adhoc.getState()
	
	if asl.adhoc_state == 0 then return 0 end
	if asl.isConected == false then return 1 end
	if asl.user.profile ~= "PSP2" then return 2 end
	if func == nil then return 3 end
	
	local pong = nil
	
	while pong == nil do
		pong = Adhoc.recv()	
	end

	local data = func(pong)
	
	if data == false then 
		Adhoc.send("no")
		Adhoc.term()
		return false
	end
	
	Adhoc.send("yes")
	
	-- Aqui va el cuerpo principal de recivido
end

----------------------------------------------------------------------------------------

function asl.closeConnection(func)
	Adhoc.term()
end

function asl.getDirectoryData(ruta) -- Texto con formato para crear las carpetas necesarias en la PSP2 (cliente)
	if System.doesDirExist(ruta) == 0 then return 0 end
	
	local result = "[CD]/"..string.format("<%.38s>", ruta )..":"
	result = result..asl.addformato(result,ruta,#ruta)
	
	return result
end

function asl.mkDirectoryData(ruta_destino,data)
	rd = ruta_destino

	tipo = string.sub(ruta,1,4)
	data = string.sub(ruta,4,#data)
	
	if tipo ~= "[CD]" then return 0 end
	
	local tabla string.explode(data,":") --------------- >> PENDIENTE: Crear esta  funcion (no esta incluida en lhm)
	
	for i = 1,#tabla do
		System.createDirectory(rt..tabla)   
	end
	
end

function asl.addformato(texto,ruta,cl)

	files = System.listDirectory()
	
	for i = 1,#files do
		if files[i].directory == true then
			nombre  = string.sub(files[i].name,cl,#files[i].name)
			texto = texto..nombre..":"
			texto = texto..asl.addformato(texto,files[i].name,cl)
		end
	end
end