----_Modulo autoboot para el manejo del plugin autoeboot.prx_----

autoboot = {}
 
if system.isGO == true then
	autoboot.ms = "ef0:/"
else
	autoboot.ms = "ms0:/"
end

function autoboot.active() --- instala y activa correctamente el plugin autoeboot.prx en el vsh
	if autoboot.isCorrupted() == true then return false end
	if autoboot.isInstall() == false then return false end
	
	files.mkdir(autoboot.ms.."seplugins")
	if files.exists(autoboot.ms.."seplugins") == false then files.mkdir(autoboot.ms.."seplugins/") end
	
	uld.writeFile(autoboot.ms.."seplugins/Config.ROE","AUTO="..system.path.."/EBOOT.PBP\r\nAUTOBOOT=YES","w+")
end

function autoboot.desactive()
	if files.exists(autoboot.ms.."seplugins/Config.ROE") then
		--files.remove(autoboot.ms.."seplugins/Config.ROE",true)
		uld.writeFile(autoboot.ms.."seplugins/Config.ROE","AUTO="..system.path.."/EBOOT.PBP\r\nAUTOBOOT=NO","w+")
	end
end

function autoboot.writeVSH()

	if autoboot.isInstall() then return end
	
	if files.exists(autoboot.ms.."seplugins/vsh.txt") == false then
		uld.writeFile(autoboot.ms.."seplugins/vsh.txt",system.path.."/AUTOBOOT/autoboot.prx 1","w+")
		return 
	end
	
	local plugins = uld.filesRead(autoboot.ms.."seplugins/vsh.txt")

	if #plugins == 0 then
		uld.writeFile(autoboot.ms.."seplugins/vsh.txt",system.path.."/AUTOBOOT/autoboot.prx 1","w+")
		return 
	end

	if ppmanager == nil then
		include("ppmanager") --- incluimos la libreria PSP plugin manager
	end
	
	local plugin_list = ppmanager.loadPlugins("vsh.txt")
	local plugin_list = ppmanager.install(plugin_list,system.path.."/AUTOBOOT/autoboot.prx","1","vsh.txt")
	
	table.insert(plugin_list,1,plugin_list[#plugin_list])
	table.remove(plugin_list,#plugin_list)
	
	ppmanager.save(plugin_list,"vsh.txt")
end

function autoboot.dropVSH()

if files.exists(autoboot.ms.."seplugins/vsh.txt") == false then return end

local plugins = uld.filesRead(autoboot.ms.."seplugins/vsh.txt")

if table.maxn(plugins) == 0 then
return 
end

local result = {}

for i = 1,#plugins do 
	local linea = plugins[i]
	if string.numtok(linea,"FISHELL") >= 2 then
	
	else
		table.insert(result,linea)
	end
end

uld.writeFile(autoboot.ms.."seplugins/vsh.txt",string.format(table.concat(result,"\n")),"w+")
end

function autoboot.isCorrupted() --- comprueva si los archivos del autoeboot estan completos (internamente)
if files.exists(system.path.."/AUTOBOOT/autoboot.prx") == false then return true end
return false
end

function autoboot.isInstall()
if files.exists(autoboot.ms.."seplugins/vsh.txt") == false then return false end

local plugins = uld.filesRead(autoboot.ms.."seplugins/vsh.txt")

if table.maxn(plugins) == 0 then	
	return false
end

local result = false

for i = 1,#plugins do 
	local linea = plugins[i]
	if string.numtok(linea,"FISHELL") >= 2 then
		if string.numtok(string.lower(linea),"autoboot.prx") >= 2 then
			result = true
			break
		end
	end
end

return result
end

function autoboot.isActive() --- comprueva si los archivos del autoeboot estan completos (externamente)

if files.exists(autoboot.ms.."seplugins/Config.ROE") then
	return true
else
	return false
end 

end
