--- Exception manager
--- Modulo escrito por zerozelta

EXM = {} 
EXM.Error = nil

function EXM.try(func,func_exception,A,B,C) --- A B y C son argumentos de la funcion func
	if func == nil then return false end
	
	local sts 
	local err
	
	sts,err = pcall(func,A,B,C)
	
	if sts == false then 
		EXM.Error = err 			--- Estableciendo enlace global del error
		func_exception(EXM.Error)	--- Iniciando funcion para para solucionar el problema
		return false
	end
	
	return true
end

function EXM.mkReport()
	local user
	local fecha = os.date()
	
	if LOG_USER ~= nil then
		user = LOG_USER
	else
		user = "Not login"
	end
	
	local report = "[ "..user.." ] ".."[ "..fecha.." ]  "..EXM.Error.."\r\n"
	
	uld.writeFile("ms0:/FISHELL/RDS/exception_report.txt",report,"a")
end

function EXM.app_exception(error)
	local id = fishbar.apps[fishbar.apps_focus].id
	
	EXM.img_background = screen.toimage()
	EXM.img_background:blit(0,0)
	draw.fillrect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(255,255,255,190))
	draw.rect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(30,30,30,230))
	screen.flip()
	
	EXM.img_window = image.load("ms0:/FISHELL/IMG/SYSTEM/exception/app_exception.png")
	kernel.postImage(EXM.img_background) 
	
	if sonido ~= nil and sonido.obj ~= nil then
		sonido.obj:pause()
	end	
	
	system.sleep(500) 			--- Esperando 1000 milisegundos (1 segundo)
	EXM.mkReport(error)			--- Escribiendo reporte del error
	usb.on()					--- Activando drive USB
	
	for i = 0,255,10 do
		EXM.app_exception_draw(i,id)
	end
	
	while true do
		if EXM.app_exception_draw(255,id) == true then break end
	end
	
	for i = 255,-10,-10 do
		EXM.app_exception_draw(i,id)
	end
	
	if EXM.caso == "1" then
		lockWindowsId(id) 		--- Se bloquea la ejecucion del programa para no sufrir errores colaterales
		app.reinit(id)			--- cierra el programa y lo reinicia
	else	
		lockWindowsId(id) 		--- Se bloquea la ejecucion del programa para no sufrir errores colaterales
		app.closeAllIds(id)		--- Se cierran todas las ventanas con el id del programa que lanzo el error
	end
end

function EXM.app_exception_draw(trans,id)
	EXM.img_background:blit(0,0)
	draw.fillrect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(255,255,255,190))
	draw.rect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(30,30,30,230))
	
	EXM.img_window:blend(0,0,trans)
	
	screen.print(125,88,"La aplicacin dej de funcionar ("..id..")",0.5,color.new(50,50,50,trans),0x0)
	screen.print(95,117,EXM.Error,0.5,color.new(60,60,60,trans),0x0,"left",285)
	screen.print(89,188,"X = Reiniciar APP  |  0 = Cerrar APP",0.5,color.new(30,30,30,trans),0x0)
	
	screen.flip()
	controls.read()
	
	if controls.press("cross") then
		EXM.caso = "1"
		return true
	end
	
	if controls.press("circle") then
		EXM.caso = "2"
		return true
	end
end

function EXM.load_app_exception(error)
	EXM.mkReport(error)
	system.mensaje("Error al cargar la aplicacion","",error)
end