--- Modulo fsl.wave
--- Creacin y manupulacion de elfecto wave de FISHELL

fsl = {}
fsl.wave = {}

---_Creacion del objeto fsl.wave | retorna una tabla del tipo fsl.wave_---
function fsl.wave.new(ruta , y , velocidad)

local tmp_img_wave = image.load(ruta)
pX = 0
pY = y

objeto_wave = {img = tmp_img_wave , posX = pX , posY = pY , vel = velocidad , objY = pY }
return objeto_wave
end
------

function fsl.wave.draw(obj,trans,color_data)
if trans == nil then trans = 255 end
if trans <= 0 then return end

local tmp_img_wave = obj.img

posX = obj.posX
posY = obj.posY 
vel = obj.vel
objY = obj.objY

posX = posX + vel
if posX >= 480 then posX = 0 end
if posY < objY then posY = posY + 1 end
if posY > objY then posY = posY - 1 end

obj.posX = posX
obj.posY = posY 
obj.vel = vel
obj.objY = objY

if color_data == nil then
	tmp_img_wave:blend(posX,posY,trans)
	tmp_img_wave:blend(posX - 480,posY, trans)
else
	image.fxtint(posX,posY,tmp_img_wave,color.new(color_data.R,color_data.G,color_data.B,trans))
	image.fxtint(posX - 480,posY,tmp_img_wave,color.new(color_data.R,color_data.G,color_data.B,trans))
end

end

function fsl.wave.drawstatic(obj)
local tmp_img_wave = obj.img
posX = obj.posX
posY = obj.posY 
vel = obj.vel
objY = objY

tmp_img_wave:blend(posX,posY,100)
tmp_img_wave:blend(posX - 480,posY,100)
end

function fsl.wave.desp(obj,objetivo)
obj.objY = objetivo
end

function fsl.wave.vel(obj,velocidad)
obj.vel = velocidad
end

function fsl.drawFishWave()
	if kernel == nil or cfg.fishbar_wave ~= true then return end
	
	if fsl.fbwave == nil then
		fsl.fbwave = {}
		fsl.fbwave = { img = image.load(LOG_THEME_PATH.."CUSTOM/fishbar/wave.png") , x = 0 }
	end
	 
	image.blit(fsl.fbwave.img,2,272 - 42,fsl.fbwave.x,0,fishbar.h,40)
	image.blit(fsl.fbwave.img,2,272 - 42,fsl.fbwave.x - 480,0,fishbar.h,40)
	
	fsl.fbwave.x = fsl.fbwave.x + 1
	
	if fsl.fbwave.x >= 480 then
		fsl.fbwave.x = 0
	end
end