----- Modulo home
----- documentacion del menu home especial para FISHELL
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

home = {}

local theme_path = "ms0:/FISHELL/THEME/DEFAULT/"
if LOG_THEME_PATH ~= nil then
	theme_path = LOG_THEME_PATH
end

home.img_foco = image.load(theme_path.."CUSTOM/SYSTEM/HOME/focus.png")
home.img_bar =  image.load(theme_path.."CUSTOM/SYSTEM/HOME/barra.png")
home.img_window = image.load(theme_path.."CUSTOM/SYSTEM/HOME/screen.png")

home.font = font.load("ms0:/FISHELL/FONTS/fish_2.pgf")
home.brilloA = brightness.new("blanco")

home.foco_pos = 1
home.barPosition = -28
home.winw = home.img_window:width();
home.winh = home.img_window:height();
home.focus_base = 117
home.focus_y = 117
home.salir = false

home.usb_state = { activado = false , conectado = false , establesido = false , y = 272 ,  brillox = 0 , trans = 0 , img = image.load(theme_path.."CUSTOM/SYSTEM/HOME/usb_drive.png")}
home.menu = {}

function home.drawInfo(trans)	

	home.img_bar:blend(0,home.barPosition,trans)
	
	if trans == 255 then
		home.barPosition = home.barPosition + 1
	else
		if home.salir == true then
			home.barPosition = home.barPosition - 1
		end
	end
	
	if home.barPosition > 0 then home.barPosition = 0 end
	
	screen.print(383,6 + home.barPosition,os.date("%I:%M:%S %p"),0.6,color.new(50,50,50,trans),color.new(200,200,200,trans))
	
	if LOG_USER ~= nil then 
		screen.print(26,6 + home.barPosition,"["..LOG_USER.."]",0.6,color.new(50,50,50,trans),color.new(200,200,200,trans))
	else
		screen.print(26,6 + home.barPosition,"[sesion no iniciada]",0.5,color.new(50,50,50,trans),color.new(200,200,200,trans))
	end
end

function home.init()
	if brightness == nil then system.dofile("ms0:/FISHELL/SRC/DOC/brightness.lua") end
	
	if cfg.joystick_enabled  == true then
		controls.analogtodigital(60)   
	end
	
	home.salir = false
	home.foco_pos = 1
	home.usb_state.y = 272
	home.usb_state.brillox = 0
	home.usb_state.trans = 0
	home.barPosition = -28
	home.window_trans = -100
	home.focus_y = 123
	home.usb_status = usb.status();
end

function home.free()
	home.brilloA = nil

	home.bars.int = nil
	home.bars.y2 = nil
	home.bars.te = nil
	home.salir = nil
	home.foco_pos = nil
	home.usb_state.y = nil
	home.usb_state.brillox = nil
	home.usb_state.trans = nil
	home.window_trans = nil

	collectgarbage("collect")
end

function home.leerControles()
	controls.read()

	if controls.press(control.config["select"]) then
		if home.foco_pos == 1 then
			system.runPortal("ms0:/FISHELL/SRC/PORTAL/SHUTDOWN")
		else
			if usb.status() == true then
				usb.off()
				home.usb_status = false
			else
				usb.on()
				home.usb_status = true
			end
		end
		
		controls.read()
		return
	end

	if controls.press("up") then 
		home.foco_pos = home.foco_pos - 1 
		if home.foco_pos <= 0 then home.foco_pos = 2 end
	end

	if controls.press("down") then 
		home.foco_pos = home.foco_pos + 1
		if home.foco_pos > 2 then home.foco_pos = 1 end
	end

	if controls.press(control.config["home"]) or controls.press(control.config["back"]) then
		home.salir = true
	end

end

function home.printList(a)
	if a ~= 255 then return end
	
	trans = home.window_trans
	trans = trans + 10
	
	if trans > 255 then trans = 255 end
	home.window_trans = trans
	
	home.img_window:blend((480 / 2) - (home.winw / 2),(272 / 2) - (home.winh / 2),trans)
	
	---- aqui pintamos el foco
	home.img_foco:blend(103,home.focus_y,trans)
	----------
	local fp = home.focus_base + ((home.foco_pos - 1) * 22)
	
	if home.focus_y > fp then home.focus_y = home.focus_y - 2 end
	if home.focus_y < fp then home.focus_y = home.focus_y + 2 end
	
	screen.print(home.font,103 + 5,117 + 4,"Menu de salida",0.6,color.new(30,30,30,trans),0x0)
	
	if home.usb_status == true then
		screen.print(home.font,103 + 5,117 + 26,"Desactivar drive USB",0.6,color.new(30,30,30,trans),0x0)
	else
		screen.print(home.font,103 + 5,117 + 26,"Activar drive USB",0.6,color.new(30,30,30,trans),0x0)
	end
	
end

function home.usb_drive(trans)
	st = usb.state()
	if st.connected and trans == 255 then home.usb_blit_drive(-3,getText("conexion usb")) return else home.usb_blit_drive(3,getText("conexion usb")) end
end

function home.usb_blit_drive(metodo,paleta)

home.usb_state.trans = home.usb_state.trans - (metodo * 2)
home.usb_state.y = home.usb_state.y + metodo

if home.usb_state.trans < 0 then home.usb_state.trans = 0 return end
if home.usb_state.trans > 255 then home.usb_state.trans = 255 end

if home.usb_state.y > 272 then home.usb_state.y = 272 return end
if home.usb_state.y < 212 then home.usb_state.y = 212 end

if home.usb_state.img == nil then home.usb_state.img = image.load(theme_path.."CUSTOM/SYSTEM/HOME/usb_drive.png") end
if home.brilloA == nil then home.brilloA = brightness.new("blanco") end

home.usb_state.brillox = home.usb_state.brillox + 2
if home.usb_state.brillox >= 575 then home.usb_state.brillox = -50; home.brilloA.trans = 0 end

brightness.draw(home.brilloA,home.usb_state.brillox,272 - 50 + (home.usb_state.y - 212),6)
home.usb_state.img:blend(0,home.usb_state.y,home.usb_state.trans) 
screen.print(home.font,50,home.usb_state.y + 43,paleta,0.7,color.new(60,60,60,home.usb_state.trans),color.new(250,250,250,home.usb_state.trans))
end

function home.draw(trans)
	if trans ~= 255 then home.screen:blend(0,0,255) end
	
	if IMG_FONDO ~= nil then
		IMG_FONDO:blend(0,0,trans)
	elseif ids.fondo ~= nil then
		ids.fondo:blend(0,0,trans)
	else
		draw.fillrect(0,0,480,272,color.new(255,255,255,trans))
	end
	
	home.printList(trans)
	home.drawInfo(trans)
	home.usb_drive(trans)
	
	screen.flip()
	home.leerControles()
	sonido.runDrive() 			-- Avilita el drive de sonido
	power.tick(power.tick_all) 	-- evita que la psp apage la pantalla y se suspenda
end

function home.run()
home.screen = screen.toimage()
home.init()

for i = 0,255,15 do
	home.draw(i)
end

while true do
	home.draw(255)
	if home.salir == true then break end
end

for i = 255,-12,-12 do
	home.draw(i)
end

if kernel ~= nil then kernel.postImage(home.screen) end
controls.analogtodigital(0) 
end