--[[ Memory Stick Sender (FISHELL Versin) ]]--
-- @ Autor: zerozelta | Agradecimientos a chimecho (GCREW)

-- Requiere la libreria ULD (@zerozelta) exclusiva de fishell para su funcionamiento

-- Progresos:
---- Ya se envian exitosamente un archivo menor a 22Mb a la raiz de la MS huesped
---- Ya se pueden enviar archivos de cualquier tamao dividido en paquetes (Recomendado menos de 60 MB)
---- Se esta trabajando en poder enviar directorios completos.....
---- Se esta trabajando en la deteccion automatica de memorias
---- Se esta trabajando en una interfaz mas agradable

MSS = {}
MSS.PACK = {}  --- Paquete 1 Contiene datos de la transferencia de archivos
MSS.SIZE_PACK = (os.getfreememory() / 2) - 600000  --- Establece el tamao de los paquetes de acuerdo a la ram (Adaptable a PSPs 1000 con menor RAM) (21 Mb p/p en psp 2000)
MSS.BUFFER = 1024 * 25 -- 25 Kb de buffer por lectura/escritura
MSS.PACKS_REQUEST = 1 -- Paquetes requeridos por un envio (Se actualiza y ajusta automaticamente)
MSS.isPackChange = false --- Valor del cambio de paquete (Se actualiza y ajusta automaticamente)
MSS.BytesCargadosUltimo = 0 --- bytes cargados del ultimo archivo (Se actualiza y ajusta automaticamente)
MSS.BytesEscritosUltimo = 0 --- Cantidad de bytes escritos en el ultimo archivo (Se actualiza y ajusta automaticamente)

function MSS.Read(ruta)	--- hace un calculo inicial del estado de los dispositivos

	local RAM = os.getfreememory()
	local SIZE = MSS.getFileSize(ruta)
	
	--system.mensaje("Falta de meoria RAM","","RAM: "..RAM.."  SIZE: "..SIZE.."  PAQUETE: "..MSS.SIZE_PACK)
	
	MSS.PACKS_REQUEST = math.ceil(SIZE / MSS.SIZE_PACK) -- Se actualiza el numero de paquetes requeridos
	
	MSS.isPackChange = false
	MSS.BytesCargadosUltimo = 0
	MSS.BytesEscritosUltimo = 0
	
	if MSS.PACKS_REQUEST > 1 then
		return false,1 --- Se requiere mas de 1 paquete
	end
	
	return true
end

function MSS.crearSolicitud(ruta,destino) -- Crea una solicitud de envio para identificar la memoria anfitrion y la memoria huesped
	if ruta == nil or destino == nil then return end
	uld.writeFile("ms0:/FISHELL/ms-ms.send",ruta.."\n"..destino,"w+")
end

function MSS.InitSend(ruta,reiniciado,destino) -- Funcion que inicia el proceso de envio de archivos
	if reiniciado ~= true then  --- comprueva que se haya reiniciado el fishell para obtener mayor RAM de acceso
		MSS.crearSolicitud(ruta)
		return
	end
	
	system.loadFunctionsLanguage(INSTALL_LENGUAGE)

	uld.writeFile("ms0:/FISHELL/ms-ms.send","[DISABLED]","w+")
	
	MSS.lineas = {}
	uld.console.println(MSS.lineas,getText("iniciando via ms"))
	
	local isTrue,num = MSS.Read(ruta)
	
	if isTrue == false then
	
	end
	
	MSS.PACK.n_archivo = ruta
	MSS.PACK.n_destino = destino
	MSS.PACK.o_archivo = uld.getFile(ruta)
	MSS.PACK.n_padre = files.nofile(ruta)
	MSS.PACK.paquete = 0
	MSS.PACK.BytesCargados = 0
	MSS.PACK.n_byte = 0
	MSS.PACK.ranuras = {}
	
	
	uld.console.println(MSS.lineas,"")
	uld.console.println(MSS.lineas,getText("archivo")..": "..ruta)
	uld.console.println(MSS.lineas,getText("tamao")..": "..files.sizeformat(MSS.PACK.o_archivo.size))
	uld.console.println(MSS.lineas,getText("paquetes envio")..": "..MSS.PACKS_REQUEST)
	uld.console.println(MSS.lineas,"")
	
	if uld.console.option(MSS.lineas,getText("x comenzar envio ram")) == false then
		system.efectDifuse()
		MSS.finish_exit()
		return
	end
	
	MSS.NextPack()
	
	MSS.ui.prinln(getText("retira ms1 inserta ms2"))
	MSS.ui.waitToChange("ms1")
	
	MSS.free()
	system.efectDifuse()
end

function MSS.loadToRam(ruta,mismoArchivo)
	
	MSS.ui.prinln("[MS1]-[RAM]  "..files.nopath(ruta).." "..getText("cargando"))
	MSS.ui.SetProgress(0)
	
	if MSS.ArchivoFocus == nil then
		MSS.PACK.ranuras[#MSS.PACK.ranuras + 1] = {} --- Crea una ranura (el equivalente a un archivo) nueva
		MSS.PACK.ranuras[#MSS.PACK.ranuras].nombre = files.nopath(ruta)
	end
	
	local BytesRestantes
	local tamaoArchivo 
	local BytesCargadosAhora = 0
	
	local finDelPaquete = false
	
	if MSS.ArchivoFocus == nil then
		MSS.ArchivoFocus = io.open(ruta,"r");  -- Se abre el archivo de origen en la MS1
		MSS.BytesCargadosUltimo = 0
		BytesRestantes = uld.getFile(ruta).size -- Obteniendo bytes del archivo
		MSS.PACK.ranuras[#MSS.PACK.ranuras].size = BytesRestantes
		tamaoArchivo = BytesRestantes
	else
		MSS.ArchivoFocus = io.open(ruta,"r"); 
		MSS.ArchivoFocus:seek("set",MSS.BytesCargadosUltimo)
		BytesRestantes = MSS.PACK.ranuras[#MSS.PACK.ranuras].size
		BytesRestantes = BytesRestantes - MSS.BytesCargadosUltimo
		tamaoArchivo = MSS.PACK.ranuras[#MSS.PACK.ranuras].size
	end
	
	while BytesRestantes > 0 do

		local buff2 = math.min(MSS.BUFFER,BytesRestantes) -- Buffer dinamico que contiene el limite maximo de bytes en caso de ser requeridos
		
		if (MSS.PACK.BytesCargados + buff2) >= MSS.SIZE_PACK then
			--- en este caso ya se ha cargado la RAM con el maximo de informacion permitida por paquete
			--- Se pedir que escriba los datos en la memoria huesped y vuelva a cargar nuevos datos en la memoria anfitrion para continuar el envio
			 
			buff2 = MSS.SIZE_PACK - MSS.PACK.BytesCargados
			finDelPaquete = true
		end
		
		table.insert(MSS.PACK.ranuras[#MSS.PACK.ranuras],MSS.ArchivoFocus:read(buff2)) --- pasando bytes fisicos (MS) a bytes virtuales (RAM)
		BytesRestantes = BytesRestantes - buff2   -- Reducioendo la cantidad de bytes faltantes
		MSS.PACK.BytesCargados = MSS.PACK.BytesCargados + buff2 -- aadiendo cantidad de bites cargados
		MSS.BytesCargadosUltimo = MSS.BytesCargadosUltimo + buff2 -- aadiendo cantidad de vites cargados del ultimo archivo
		BytesCargadosAhora = BytesCargadosAhora + buff2
		
		local porcenta =  (100 / tamaoArchivo) * MSS.BytesCargadosUltimo
		local porcentb =  (100 / math.min(MSS.SIZE_PACK,tamaoArchivo)) * BytesCargadosAhora
		
		MSS.ui.editLine(nil,"[MS1]-[RAM]  "..files.nopath(ruta).." "..math.floor(porcentb).."% ("..math.floor(porcenta).."%)")
		
		MSS.ui.SetProgress(porcentb,porcenta)
		
		if finDelPaquete == true then
			BytesRestantes = 0
			break
		end
		
		collectgarbage()
	end
	
	if finDelPaquete == true then
			MSS.PACK.n_archivo = ruta
			MSS.PACK.n_byte = MSS.BytesCargadosUltimo
			MSS.isPackChange = true 
			MSS.ArchivoFocus:close()
			MSS.ArchivoFocus = "enabled"
			---system.mensaje("fin","","")
			return
	end
	
	MSS.PACK.n_byte = 0
	MSS.ui.editLine(nil,"[MS1]-[RAM]  "..files.nopath(ruta).." "..getText("completo"))
	MSS.ArchivoFocus:close()
	MSS.ArchivoFocus = nil
end


function MSS.sendFile(index,mismoArchivo)
	if MSS.PACK.ranuras[index] == nil then return false end --- comprobando que exista la ranura con el index asociado
	
	MSS.ui.prinln("[RAM]-[MS2] "..MSS.PACK.ranuras[index].nombre.." "..getText("cargando"))
	MSS.ui.SetProgress(0)
	
	local modo = "w"
	local BytesEscritosAhora = 0
	
	if mismoArchivo == true then
		modo = "a"
	end
	
	if mismoArchivo ~= true then
		uld.writeFile(MSS.PACK.n_destino.."/"..MSS.PACK.ranuras[index].nombre,"","w+") --- Creamos o sobreescribimos el archivo
		MSS.BytesEscritosUltimo = 0
	end
	
	local archivo = io.open(MSS.PACK.n_destino.."/"..MSS.PACK.ranuras[index].nombre,modo); --- abrimos el archivo creado en modo asociado (w|a+)
	archivo:seek("end")
	
	for i = 1,#MSS.PACK.ranuras[index] do
		archivo:write(MSS.PACK.ranuras[index][i]) --- Grabando los bytes de cada tabla de datos (uno por uno)
		
		MSS.BytesEscritosUltimo = MSS.BytesEscritosUltimo + #MSS.PACK.ranuras[index][i]
		BytesEscritosAhora = BytesEscritosAhora + #MSS.PACK.ranuras[index][i]
		
		local porcenta = (100 / MSS.PACK.ranuras[index].size) * MSS.BytesEscritosUltimo
		local porcentb =  (100 / math.min(MSS.SIZE_PACK,MSS.PACK.ranuras[index].size)) * BytesEscritosAhora
		
		MSS.ui.editLine(nil,"[RAM]-[MS2] "..MSS.PACK.ranuras[index].nombre.." "..math.floor(porcentb).."% ("..math.floor(porcenta).."%)")
		MSS.ui.SetProgress(porcentb,porcenta)
	end
	
	MSS.ui.editLine(nil,"[RAM]-[MS2] "..MSS.PACK.ranuras[index].nombre.." "..getText("completo"))
	
	archivo:flush();
	
	archivo:close();
	
	MSS.liberarRanuras(index)
end

function MSS.liberarRanuras(index)
	local nombre = tostring(MSS.PACK.ranuras[index].nombre)
	local tamao = tostring(MSS.PACK.ranuras[index].size)
	
	MSS.PACK.ranuras[index] = {}
	collectgarbage("collect")
	
	MSS.PACK.ranuras[index] = {}
	MSS.PACK.ranuras[index].nombre = nombre
	MSS.PACK.ranuras[index].size = tamao
end

function MSS.loadPack(change)
	
	collectgarbage("collect")
	MSS.filesToLoad = {}
	
	if MSS.PACK.o_archivo.directory == false then
		MSS.loadToRam(MSS.PACK.n_archivo,change)
	else
		MSS.filesToLoad = {}
	end
end

function MSS.runPack(change)
	for i = 1,#MSS.PACK.ranuras do
		MSS.sendFile(i,change)
	end
end

function MSS.NextPack()
	MSS.PACK.BytesCargados = 0
	
	MSS.PACK.paquete = MSS.PACK.paquete  + 1
	
	if MSS.PACK.paquete > MSS.PACKS_REQUEST then
		return 
	end 
	
	if MSS.PACK.paquete > 1 then 
		MSS.ui.prinln(getText("retire ms2"))
		MSS.ui.prinln(getText("inserte ms1"))
		MSS.ui.waitToChange("ms1")
	end
	 
	local change = false

	if MSS.isPackChange == true or MSS.ArchivoFocus == nil and MSS.PACK.paquete ~= 1 then
		MSS.isPackChange = false
		change = true
	end
	
	MSS.ui.prinln()
	MSS.ui.prinln("[RAM] "..getText("cargando paquete")..": "..MSS.PACK.paquete.."/"..MSS.PACKS_REQUEST)
	
	MSS.loadPack(change)  --- Cargando el paquete actual
	
	MSS.ui.prinln()
	MSS.ui.prinln(getText("paquete").." "..MSS.PACK.paquete.." "..getText("cargado en ram"))
	MSS.ui.prinln()
	MSS.ui.prinln(getText("retire ms1"))
	MSS.ui.prinln(getText("inserte ms2"))
	
	MSS.ui.waitToChange("ms2")
	MSS.ui.prinln()
	MSS.ui.prinln(getText("escribiendo paquete").." "..MSS.PACK.paquete.." "..getText("no retire ms2"))
	MSS.ui.prinln()
	
	MSS.runPack(change)   --- Escribiendo el paquete actual ya cargado
	
	MSS.ui.prinln("")
	MSS.ui.prinln(getText("paquete").." "..MSS.PACK.paquete.."/"..MSS.PACKS_REQUEST.." "..getText("enviado correctamente"))
	MSS.ui.prinln("")
	
	MSS.NextPack()  --- Accediendo al siguente paquete
	
end

function MSS.getFileSize(ruta)
	local FILE = uld.getFile(ruta)
	
	if FILE.directory == true then
		MSS.tamao = 0
		MSS.getDirectorySize(ruta)
	else
		return FILE.size
	end
end

function MSS.getDirectorySize(ruta)
	local folder = files.list(ruta)
	
	for i = 1,#folder do
		if folder[i].directory == true then
			MSS.getDirectorySize(ruta)
		else
			MSS.tamao = MSS.tamao + folder[i].size
		end
	end
end

function MSS.free()
	MSS.PACK = nil
	MSS.PACK = {}
	
	collectgarbage("collect")
end

function MSS.finish_exit()
	MSS.free()
end

--------------------------------------------------------------------
----------------------- Interfaces Graficas ------------------------
--------------------------------------------------------------------
--- no aplicada an

MSS.ui = {} -- variable de la interfaz grafica
MSS.ui.lines = {} --- interfaz de lineas
MSS.ui.pbar_1 = 0
MSS.ui.pbar_2 = 0

function MSS.loadInterfaz()
	MSS.ui.background = image.load("ms0:/FISHELL/IMG/SYSTEM/SCREEN/ms_ms_sender.png")
end

function MSS.ui.prinln(texto,color_,timer)

	if timer == nil then
		timer = 30
	end
	
	if texto == nil then 
		texto = ""
	end
	
	if color_ == nil then 
		color_ = color.new(0,0,0)
	end
	
	table.insert(MSS.ui.lines,{text = texto, color = color_ })
	MSS.ui.repaint()
	screen.waitvblankstart(timer)
end

function MSS.ui.editLine(index,texto)
	if index == nil then 
		index = #MSS.ui.lines
	end
	
	MSS.ui.lines[index].text = texto
	MSS.ui.repaint()
end

function MSS.ui.repaint()
	MSS.ui.background:blend(0,0)
	MSS.ui.drawLines()
	MSS.ui.drawProgressBar()
	screen.flip()
end

function MSS.ui.drawLines()
	local init = 0
	
	if #MSS.ui.lines - 12 > 0 then
		init = #MSS.ui.lines - 12
	end
	
	for i = 1,12 do
		if MSS.ui.lines[i] == nil then break end
		local j = i + init
		if MSS.ui.lines[j] == nil then break end
		local y = 12 + ((i - 1) * 12)
		local x = 14
		
		screen.print(x,y,MSS.ui.lines[j].text,0.5,MSS.ui.lines[j].color,0x0,"scroll_right",460)
	end
end

function MSS.ui.SetProgress(interno,global)

	if interno == nil or interno < 0 or interno > 100 then
		interno = 100
	end
	
	MSS.ui.pbar_1 = interno
	
	if global ~= nil then
		MSS.ui.pbar_2 = global
	end
	
	MSS.ui.repaint()
end

function MSS.ui.drawProgressBar()
	draw.fillrect(5,176,460,17,color.new(255,255,255))
	local p1 = (460) / 100
	p1 = math.floor(MSS.ui.pbar_1) * p1
	draw.fillrect(7,177,p1,15,color.new(0,0,255))
	
	draw.fillrect(5,176 + 21,460,17,color.new(255,255,255))
	local p2 = (460) / 100
	p2 = math.floor(MSS.ui.pbar_2) * p2
	draw.fillrect(7,177 + 21,p2,15,color.new(0,0,255))
end


function MSS.ui.waitToChange(mss)
	local bucle = true
	MSS.timer =  timer.new()
	MSS.timer:start()
	
	while bucle do
	
		if MSS.timer:time() > 1500 then -- Esperamos 1.5 segundos
			return
		else
			MSS.timer:reset()
		end
		
		controls.read()
		MSS.ui.repaint()
		
		if controls.press("circle") then
			if os.message(getText("desea cancelar envio"),1) == 1 then
				bucle = false
				system.efectDifuse()
				files.remove("ms0:/FISHELL/ms-ms.send",true,true)
				MSS.finish_exit()
				os.exit()
				return
			else
				 MSS.ui.repaint()
			end
		end
		
		if mss == "ms1" then
			if files.exists("ms0:/") == true and files.exists("ms0:/FISHELL/ms-ms.send") == true then
				bucle = false
				return
			end
		else
			if files.exists("ms0:/") == true and files.exists("ms0:/FISHELL/ms-ms.send") == false then
				bucle = false
				return
			end
		end
		
	end
end

MSS.loadInterfaz()  --- Cargando interfaz de usuario