-----------------------
---- Modulo SYSTEM ----
-----------------------

-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

system = {} -- Variable global del sistema
isf = {}

system.revicion = 3.5 -- Version del sistema fishell
system.version = system.revicion -- Version del sistema fishell
system.sub_version = 0
system.sub_rev = system.sub_version
system.rev = system.version -- Version del sistema fishell
system.revicion_string = "R"..system.rev.."."..system.sub_rev -- Version del sistema fishell con formato en string
system.isGO = false 
system.path = files.cdir() -- Directorio de ejecucion del script de fishell y librerias nativas

if files.exists("ef0:/") then
	system.isGO = true
end

function system.isInstall() --- Comprueva que el sistema este instalado correctamente
	if files.exists("ms0:/FISHELL/INSTALL/install.ini") == false then return false end
	if files.exists("ms0:/FISHELL/INSTALL/install_usr.ini") == false then return false end
	if files.exists("ms0:/FISHELL/USR/RDC.rdc") == false then return false end
	if table.maxn(files.listdirs("ms0:/FISHELL/USR/")) == 0 then return false end
	if #acount.cuentas == 0 then return false end
	return true
end

function system.isCorruptedSystem() --- analiza que los componentes vitales de fishell esten en orden
	if files.nopath(files.cdir()) ~= "FISHELL" then return true end --- si no esta en la carpeta llamada FISHELL
	if system.revicion == nil then return true end
	if files.exists("RECOVERY/recovery.lua") or files.exists("RECOVERY/recovery.lue") then else return true end
	if files.exists("ms0:/FISHELL/THEME/default") then else return true end
	if files.exists("ms0:/FISHELL") then else return true end
	return false
end

function system.makeSesion(user,password,firma) -- Inicia una sesion de usuario

if system.userExist(user) == false then return end
if firma ~= "0945.8721.0902.8752" then return  end 

local cuenta = acount.getAcounTable(user) --- obteniendo cuenta del rdc (Registro de cuentas)
 
-- checar que la contraseña del registro coincida con el argumento

local code = cuenta.name..":"..os.time()

code_encrypt = uld.code.new(code,2)
uld.writeFile("ms0:/FISHELL/RDS/LOG/loged.isf",code_encrypt,"w+")
end

function system.initSystemBoot() --- Inicia el boteo de fishell
img1 = image.load("ms0:/FISHELL/IMG/BOOT/1.png")
--- img2 = image.load("ms0:/FISHELL/IMG/BOOT/2.png")

for i = 0,255,4 do
	img1:blend(0,0,i)
	screen.flip()
end

------ pasando al inicio de sesión --------
system.dofile("ms0:/FISHELL/SRC/IDS.lua")
-------------------------------------------
end

function system.isSesion() --- comprueba si esta iniciada una sesion valida
	if files.exists("ms0:/FISHELL/RDS/LOG/loged.isf") then else return false end

	local linea = uld.filesRead("ms0:/FISHELL/RDS/LOG/LOGED.ISF")
	linea = uld.code.reverse(linea[1],2)

	tabla = string.explode(linea,":")
	if #tabla ~= 2 then return false end

	isf.user = {}
	isf.user.usr = tostring(tabla[1])
	isf.user.fecha = tonumber(tabla[2])

	if isf.user == nil then return false end

	diferencia = os.time() - isf.user.fecha
	if diferencia > 86400 then return false end
	
	return true
end

function include(script)
	return system.dofile("ms0:/FISHELL/SRC/DOC/"..script..".lua")
end

function system.selectLanguage()
	return system.dofile("ms0:/FISHELL/SRC/FUNCTIONS/select_language.lua")
end

function system.scannUpdate(usuario)
	if USR_SISTEMASUBID == nil then 
		USR_SISTEMASUBID = 0
	end
	
	if tonumber(USR_SISTEMAID) < tonumber(system.rev) or tonumber(USR_SISTEMASUBID) < system.sub_version  then
		system.printLabel("03",getText("actualizando"))
		include("install_lib")			 --- Importamos la install_lib (libreria de instalacion)
		ilib.updateUser(usuario)		 --- Actualizamos al usuario
		system.closeLabel()
	end
end

function system.sleep(nan)
	local tim = timer.new()
	tim:start()
	local buc = true
	
	while buc do
		if tim:time() >= nan then
			buc = false
			break
		end
	end
end

function system.dofile(ruta) --- ejecuta un script luaDEV (encriptado o no encriptado)

	rut = string.sub(ruta,0,string.len(ruta) - 3)

	if files.exists(ruta) then
		return dofile(ruta)
	end

	if files.exists(rut.."lue") then 
		return dofile(rut.."lue")
	end

	return dofile(ruta)
end

function system.loadPatchs() --- carga todos los parches (archivos .fps) dentro de la carpeta PATCH
	--- Funcion no habilitada aún
end

function system.userExist(nick) --- comprueva si existe el usuario con el nick espesificado (en fisico)
	if acount.isExist(nick) == false then return false end
	if files.exists("ms0:/FISHELL/USR/"..nick) == false then return false end
	
	return true
end

function system.mensaje(msn_titulo,msn_icono,msn_texto,imagen) --- muestra un mensaje en pantalla
	if mensaje == nil then system.dofile("ms0:/FISHELL/SRC/DOC/mensaje.lua") end
	
	if msn_icono == nil then
		msn_icono = ""
	end
	
	mensaje.print(msn_titulo,msn_icono,msn_texto,imagen)
end

function system.mensajeCritico(msn_texto,imagen) --- muestra un mensaje en pantalla (En rojo)
	system.dofile("ms0:/FISHELL/SRC/DOC/mensaje_critico.lua")
	system.messen.print(msn_texto,imagen)
end

function system.printLabel(id,texto) --- pinta una etiqueta en la pantalla (se cierra unicamente cuando es demandado)
	if label == nil then system.dofile("ms0:/FISHELL/SRC/DOC/label.lua") end
	
	label.print(id,texto)
end

function system.loadLanguage(lengua) --- carga un script de lenguage basandose en su argumento
	lng = {} --- Inicializando tabla de lenguage
	if files.exists("ms0:/FISHELL/LANG/"..lengua.."/main.lua") then
		dofile("ms0:/FISHELL/LANG/"..lengua.."/main.lua")
	else
		if files.exists("ms0:/FISHELL/LANG/unknown/main.lua") then
			dofile("ms0:/FISHELL/LANG/unknown/main.lua")
		else
			system.mensajeCritico("'unknown' language is not exists error-code: 002")
		end
	end
end

function system.loadFunctionsLanguage(lengua)
	lng = {} --- Inicializando tabla de lenguage
	
	if files.exists("ms0:/FISHELL/LANG/"..lengua.."/functions.lua") then
		dofile("ms0:/FISHELL/LANG/"..lengua.."/functions.lua")
	else
		if files.exists("ms0:/FISHELL/LANG/unknown/functions.lua") then
			dofile("ms0:/FISHELL/LANG/unknown/functions.lua")
		else
			system.mensajeCritico("'unknown' language is not exist error-code: 002")
		end
	end
end

function system.loadLanguageScript(script)
	if files.exists("ms0:/FISHELL/LANG/"..LOG_LENGUAGE.."/"..script) then
		dofile("ms0:/FISHELL/LANG/"..LOG_LENGUAGE.."/"..script)
	end
end

function system.closeLabel() --- cierra una etiqueta abierta
	if label == nil then return end
	if label.close == nil then return end
	label.close()
end

function system.reloadSystem() --- reinicia el sistema
	if files.exists(system.path.."/EBOOT.pbp") then else system.mensajeCritico("error-code: 004") end
	system.efectDifuse()
	os.runeboot(system.path.."/EBOOT.pbp")
end

function system.exit() --- sale al XMB de la psp
	system.efectDifuse()

	if autoboot == nil then 
		system.dofile("ms0:/FISHELL/SRC/DOC/autoboot.lua")
	end

	autoboot.desactive()

	if files.exists("ms0:/FISHELL/RDS/LOG/loged.isf") then files.remove("ms0:/FISHELL/RDS/LOG/loged.isf") end
	if files.exists("ms0:/FISHELL/RDS/inicial.ice") then files.remove("ms0:/FISHELL/RDS/inicial.ice") end

	os.exit()
end

function system.efectDifuse() --- Efecto de desvanesimiento
	local capt = screen.toimage()
	local effd = image.create(480,272,color.new(0,0,0))
	for i = 0,255,11 do
		capt:blend(0,0,255)
		effd:blend(0,0,i)
		screen.flip()
	end
	effd:blit(0,0)
	screen.flip()
end

function system.shutdown() -- Apaga la PSP
	if launch == nil then system.dofile("ms0:/FISHELL/src/doc/launcher.lua") end
	launch.lhms("shutdown.lua")
end

function system.runPortalKernel(data) -- nucleo para los portales del shell (funciones limitadas)
	
	if data == nil then
		local data = {}
	end
	--_esta funcion requiere haber cargado anteriormente el kernel del shell para su uso_--
	
	if kernel == nil then return end

	control.runDrive() --- drive de los controles
	sonido.runDrive() --- drive de las pistas de audio
	
	if control.press("home") and data.home ~= false then home.run() end
	
	if controls.press("start") then
	--- Completar despues
	end

	if controls.hold() == true then standby.init() end

	power.tick(power.tick_all) -- evita que la psp apage la pantalla y se suspenda
	
	screen.flip()

	--[[ Completar conforme el kernel principal sea modificado ]]--
end

function system.loadOsk() -- Carga los datos del teclado osk
	if osk == nil then
		system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua")
	end
end

function system.runPortal(id) --- Corre un portal de fishell (aplicacion no ventana)
	
	if files.exists("ms0:/FISHELL/PORTAL/"..id.."/loading.png") then
		system.printLabel("ms0:/FISHELL/PORTAL/"..id.."/loading.png","")
	else 
		if files.exists(id.."/loading.png") then
			system.printLabel(id.."/loading.png","")
		else
			system.printLabel("load","")
		end
	end
	
	if files.exists("ms0:/FISHELL/PORTAL/"..id.."/portal.lua") or files.exists("ms0:/FISHELL/PORTAL/"..id.."/portal.lue") then
		PORTAL_MODE = true
		PORTAL_ID = id
		return system.mkRunPortal("ms0:/FISHELL/PORTAL/"..id)
	else
		if files.exists(id.."/portal.lua") or files.exists(id.."/portal.lue") then
			PORTAL_MODE = true
			PORTAL_ID = files.nopath(id)
			return system.mkRunPortal(id)
		end
	end
	
	return nil
end

function system.mkRunPortal(path)
	controls.read()
	
	if cfg.joystick_enabled == true then
		controls.analogtodigital(60)
	else
		controls.analogtodigital(0)
	end
	
	portal = {}
	portal.path = path
	portal.open = true
	
	local values = system.dofile(path.."/portal.lua")
	
	system.closeLabel()
	system.disabledPortal()
	controls.analogtodigital(0)
	portal = nil
	collectgarbage("collect")
	
	return values
end

function system.disabledPortal() -- Cierra portal
	PORTAL_MODE = false
	return nil
end

function system.closeSesion() -- Funcion para cerrar sesion

	if kernel == nil or LOG_USER == nil then
		return 
	end
	
	system.efectDifuse()
	
	local background = image.load("ms0:/FISHELL/IMG/SYSTEM/sesion.png")
	
	local tw = screen.textwidth(lng["cerrando sesion"],0.65)
	local ps = (480 - tw) / 2
	
	for i = 0,255,9 do
		background:blend(0,0,i)
		screen.print(ps,133,getText("cerrando sesion"),0.65,color.new(255,255,255,i),color.new(104,164,220,i))
		screen.flip()
	end
	
	screen.waitvblankstart(60)
	
	files.remove("ms0:/FISHELL/RDS/LOG/loged.isf",true)
	app.trans_blackscreenB = 0
	LOG_USER = nil
		
	system.reloadSystem()
end

function getText(texto,variable) --- Obtiene texto de del lenguaje actual (previamente cargado)
	if lng[texto] == nil and variable == nil then
		return "(unknown)"
	end
	
	if variable ~= nil then
		if variable.lng ~= nil and variable.lng[texto] ~= nil then
			return variable.lng[texto]
		else
			return "(unknown)"
		end
	end
	
	return lng[texto]
end

function system.getDefaultConnection()
	if kernel == nil then return end
	if LOG_USER == nil then return end
	
	if files.exists("ms0:/FISHELL/USER/"..LOG_USER.."/CUSTOM/connection.txt") == false then return end
	
	local conect = uld.filesRead("ms0:/FISHELL/USER/"..LOG_USER.."/CUSTOM/connection.txt")[1]
	
	return tonumber(conect)
end

function system.writeDefaultConnection(index)
	if kernel == nil then return end
	if LOG_USER == nil then return end
	
	uld.writeFile("ms0:/FISHELL/USER/"..LOG_USER.."/CUSTOM/connection.txt",""..index,"w+")
end

function system.connectWlan(func,a,b,c)
	system.printLabel("08","Conectando")
	
	if controls.wlan() == false then
		system.closeLabel()
		system.mensaje("Alerta","","Activa el interruptor WLAN y vuelve a intentar")
		return
	end
	
	local dc = system.getDefaultConnection()
	
	local conexion = nil
	
	if dc ~= nil then
		wlan.init(dc)
		conexion = dc
		system.sleep(2000) --- Esperamos 2 segundos
	
		if wlan.connected() == false then
			conexion = wlan.init()
			system.sleep(1000) --- Esperamos 1 segundos
			dc = nil
		else
			conexion = dc
		end
	else
		conexion = wlan.init()
		system.sleep(1000) --- Esperamos 1 segundos
	end
	
	if conexion == 0 or conexion == nil then
		wlan.init()
		system.closeLabel()
		return 0
	end
	
	system.writeDefaultConnection(conexion)
	
	system.closeLabel()
	
	if kernel ~= nil then
		kernel.wlanStatus = wlan.connected()
	end
	
	if func ~= nil then
		func(a,b,c)
	end
	
	return kernel.wlanStatus
end

function system.closeWlanConection()
	if wlan.status() == 0 then return end
	
	system.printLabel("08","Cerrando conexión")
	wlan.term()
	system.sleep(1000) -- Esperando 1 segundo
	system.closeLabel()
end

function system.loadPatchs()
	PATCH = {}
	
	if cfg.patch_loader ~= true then return end

	local lista = files.listfiles("ms0:/FISHELL/PATCH")
	
	for i = 1,#lista do
		local ext = files.ext(lista[i].name)
		if ext == "lua" or ext == "fpatch" then
			dofile(lista[i].name)		--- TAREA PENDIENTE: hacer qeu se cargen en modo aprueva de fallos
			table.insert(lista[i].name)
		end
	end
end

system.dofile("ms0:/FISHELL/SRC/DOC/acount_admin.lua") -- inicia el modulo administrador de cuentas