--- USO DE PALETAS DE MUESTRA
sdk.textfield = {}

function sdk.textfield.new(x_,y_,w_,texto_inicial)
texto_inicial = tostring(texto_inicial)

if texto_inicial == nil or texto_inicial == "nil" then 
texto_inicial = "" 
end

textfield = { type = "textfield" , x = x_ , y = y_ , w = w_ , h = 20 ,text = texto_inicial , trans = 255 , enabled = true }

return textfield
end

function sdk.textfield.draw(obj)
if obj.type ~= "textfield" then return end

local x = obj.x + sdk.x
local y = obj.y + sdk.y

if obj.y  < 0 then return end
if obj.y  + 20 > sdk.h then return end

draw.gradrect(x,y,obj.w,obj.h,color.new(20,20,20,obj.trans),color.new(20,20,20,obj.trans),color.new(130,130,130,obj.trans),color.new(130,130,130,obj.trans)) 
draw.fillrect(x + 1,y + 1,obj.w - 2,obj.h - 2,color.new(255,255,255,obj.trans))

local scroll = sdk.w - x
if sdk.w - x < sdk.w then scroll = obj.w end

if obj.text ~= nil and x > 0 then
	if screen.textwidth(obj.text, 0.6) > scroll then
		screen.print(x + 3,y + 5,"...",0.6,color.new(30,30,30,obj.trans),color.new(220,220,220,obj.trans))
		screen.print(x + obj.w - 2,y + 5,obj.text,0.6,color.new(30,30,30,obj.trans),color.new(220,220,220,obj.trans),"scroll_right",obj.w - 18)
	else
		screen.print(x + 3,y + 5,obj.text,0.6,color.new(30,30,30,obj.trans),color.new(220,220,220,obj.trans),"scroll_left",scroll - 4)
	end
end

if obj.enabled == false then
	draw.fillrect(x + 1,y + 1,obj.w - 2,obj.h - 2,color.new(55,55,150,obj.trans - 165))
end

if puntero.isOver(x,y,obj.w,obj.h) and obj.enabled == true then
	puntero.overOn("textfield")
	if control.press("select") then 
		if osk == nil then system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua") end
			sdk.textfield.setText(obj,osk.getText("TextField",obj.text))
			if obj.event ~= nil and obj.event.activate == true then
				obj.event.funcion(obj.event.id,obj)
			end
	end
	
	if control.press("menu") then
		sdk.textfield.mkpopup(obj)
	end
end

end

function sdk.textfield.setText(obj,texto_)
	if texto_ == nil then return end
	obj.text = texto_
end

function sdk.textfield.getText(obj)
return obj.text
end

function sdk.textfield.newEvent(id_,textfield,funcion_ )
textfield.event = { activate = true, id = id_ , funcion = funcion_ }
end

function sdk.textfield.mkpopup(obj)
	local eleme = {}
	
	table.insert(eleme,{ texto = "Copiar" , accion = "kernel.portapapeles = '"..obj.text.."'" , est = true })
	table.insert(eleme,{ texto = "Pegar" , accion = "" , est = true })
	table.insert(eleme,{ texto = "Borrar" , accion = "" , est = true })
	
	popup.setElements(eleme)
	popup.activate()
end

sdk.img_muestraRGB = image.load("ms0:/FISHELL/IMG/SYSTEM/SCREEN/muestra_color.png")

function sdk.paletaRGB(x,y,trans,c,f_change)
	x = x + sdk.x
	y = y + sdk.y
	
	sdk.img_muestraRGB:blend(x,y,trans)
	draw.fillrect(x + 4,y + 4,47,7,c)
	
	if puntero.isOver(x,y,70,15) then
		puntero.overOn("link")
		
		if control.press("select") then
			---- SE obtiene el color y se envia como argumento del fchange
		end
	end
end

sdk.button = {}

function sdk.button.new(argumento,action,texto,icon)
	local obj = {}
	
	if icon ~= nil and files.exists(icon) then
		obj.icon = image.load(icon)
	end
	
	obj.text = texto
	
	obj.gradientColor1 = color.new(235,235,235)
	obj.gradientColor2 = color.new(170,170,170)
	obj.focusColor = color.new(250,250,250)
	obj.borderColor = color.new(50,50,50)
	
	obj.actionPerforment = action
	obj.argument = argumento
	return obj
end

function sdk.button.draw(obj,x,y)
	x = x + sdk.x
	y = y + sdk.y
	
	local h = 4 -- tamao del borde
	local w = 4 -- tamao del borde
	local hi = 0
	local wi = 0 
	
	if obj.icon ~= nil then
		h = h + obj.icon:height() 
		w = w + obj.icon:width()
		
		hi = obj.icon:height() + 1
		wi = obj.icon:width() + 2
	end
	
	if obj.text ~= nil then
		local tw = screen.textwidth(obj.text,0.5) + 3
		w = w + tw
		h = math.max(h,18)
	end
	
	draw.gradrect(x,y,w,h,obj.gradientColor2,obj.gradientColor2,obj.gradientColor1,obj.gradientColor1)
	draw.rect(x,y,w,h,obj.borderColor)
	
	if puntero.isOver(x,y,w,h) then
		puntero.overOn("link")
		draw.fillrect(x + 1, y + 1,w - 2,h - 2,obj.focusColor)
		if control.press("select") and obj.actionPerforment ~= nil then
			obj.actionPerforment(obj.argument)
		end
	end
	
	if obj.icon ~= nil then
		obj.icon:blend(x + 2,y + 2)
	end
	
	if obj.text ~= nil then
		screen.print(x + hi + 2,y + 4,obj.text,0.5,color.new(230,230,230),color.new(135,135,135))
	end
end

sdk.r_button = {}
sdk.r_button.img_1 = image.load("ms0:/FISHELL/IMG/SYSTEM/SDK/radio_button.png")
sdk.r_button.img_2 = image.load("ms0:/FISHELL/IMG/SYSTEM/SDK/radio_button_select.png")

function sdk.r_button.new(val,texto)
	local obj = {}
	
	if val == nil then
		val = false
	end
	
	if val == true then
		val  = true
	else
		val = false
	end
	
	obj.text = texto
	obj.value = val
	
	return obj
end

function sdk.r_button.draw(obj,x,y)

	y = y + sdk.y
	x = x + sdk.x
	
	if obj == nil then return end
	
	if obj.value ~= true then
		obj.value = false
	end
	
	local th = 0
	
	if obj.text ~= nil then
		th = screen.textwidth(obj.text,0.5)
	end
	
	if puntero.isOver(x - 1,y - 1,23 + th + 2,21) then
	
		puntero.overOn("link")
		draw.fillrect(x - 1,y - 2,23 + th + 5,21,color.new(255,255,255,140))
		draw.rect(x - 1,y - 2,23 + th + 5,21,color.new(30,30,30))

		if control.press("select") then
			if obj.value == true then
				obj.value = false
			else
				obj.value = true
			end
		end
	end
	
	if obj.value == true then
		sdk.r_button.img_2:blend(x,y)
	else
		sdk.r_button.img_1:blend(x,y)
	end
	
	if obj.text ~= nil then
		screen.print(x + 23,y + 4,obj.text,0.5,color.new(30,30,30),color.new(200,200,200))
	end
	
end

function sdk.r_button.getValue(obj)
	if obj == nil then return nil end
	
	return obj.value
end