--- Modulo Full Screen ---

AFS = {} 						--- iniciamos la tabla APP Full Screen
AFS.ENABLED = false				--- definiendo que AFS esta desactivado
AFS.CLOSE = false
AFS.BACKGRUND = image.create(480,272,color.new(200,200,200))

function AFS.init(funcion,a,b,c)
	system.closeLabel()
	
	if kernel.imgload ~= nil then
		kernel.imgload:free()
		kernel.imgload = nil
	end
	
	AFS.ENABLED = true
	AFS.wall_trans = 255
	AFS.run(funcion,a,b,c)
	
	sdk.x = 0
	sdk.y = 0
	sdk.w = 480
	sdk.h = 272
	
	AFS.finish()
end

function AFS.run(funcion,a,b,c)
	AFS.initEffect() --- iniciando efecto de fullscreen
	
	while AFS.ENABLED do
		local x = 0
		local y = 0
		
		AFS.BACKGRUND:blit(0,0)
		
		AFS.wall_trans = AFS.wall_trans - 9
		if AFS.wall_trans < 0 then AFS.wall_trans = 0 end
		
		funcion(a,b,c)
		AFS.runKernel()
	end
	
	system.efectDifuse()
end

function AFS.finish()
	AFS.ENABLED = false;
	sdk.x = 8
	sdk.y = 25
	sdk.w = 463
	sdk.h = 198
	ef01 = image.create(480,272,color.new(0,0,0));
	ef01T = 255; 
	controls.read();
end

function AFS.close()
	AFS.ENABLED = false	
end

function AFS.runKernel()
	control.runDrive() --- Drive del los controles
	sonido.runDrive() --- Drive de las pistas de audio
	
	if control.old("scroll",true) then --- Controlador del SCROLL_KERNEL al presionar el boton de scroll
		app.kernel_scroll_ = true
		puntero.overOn("scroll")
	else
		control.unlock(4673)
		app.kernel_scroll_ = false
	end 
	
	puntero.draw()
	
	if AFS.wall_trans > 0 then
			draw.fillrect(0,0,480,272,color.new(0,0,0,AFS.wall_trans))
	end
		
	if kernel.imgloadFS == nil then 
		if cfg.waitrefresh == true then screen.waitvblank() end
		screen.flip()
	else
		kernel.imgloadFS:blend(0,0,255)
		screen.waitvblank()
		screen.flip()
		kernel.imgloadFS:free()
		kernel.imgloadFS = nil
		collectgarbage("collect")
	end
	
	power.tick(power.tick_all)
	
	if control.press("back") then
		AFS.close()
	end
	
	if control.press("home") then 
		home.run() --- Activa el menu home de fishell
	end
end

function AFS.initEffect()
	local img_screen = screen.toimage()
	
	for i = 0,480,7.7 do
		local w = 200 + i
		local x = (480 / 2) - (w / 2) 
		local y = (272 / 2) - (i / 2)
		
		img_screen:blend(0,0)
		draw.fillrect(x,y,w,i,color.new(0,0,0,i))
		screen.flip()
	end
	
end