----- Documentacion del modulo DRIVE -----
--- Permite la gestion de los drives de:
	-- Control
	-- Sonido
	-- UMD
	
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com


-- Inicializacion de variables --
control = {}
	control.config = {}
	control.lock_llave = nil

sonido = {}
	sonido.list = {}   --- valores: ruta,nombre,id3
	sonido.focus = 0
	sonido.playing = false
	sonido.obj = nil
	sonido.porcent = 0
	
UMD = {}
---------------------------------


----------------------------------
--[[ manejor de los controles ]]--
----------------------------------

function control.runDrive()
	controls.read()
end

function control.checKey() --- Compriva que este disponible el lector de controles
if PORTAL_MODE == true then
	return true
end

if kernel ~= nil then
	if kernel.isPopup == true then return false end
	if kernel.isOption == true then return false end
	if fishbar.panel_activado == true then return false end
	if app ~= nil and app.kernel_scroll_ ~= nil and app.kernel_scroll_ == true then return false end
end

return true
end

function control.press(accion,llave) --- Devielve true o false si se presion el boton pasado como argumento
if control.checKey() == false then return false end

-- acciones: select scroll menu back home
if accion == "up" then return controls.press("up") end
if accion == "down" then return controls.press("down") end
if accion == "left" then return controls.press("left") end
if accion == "right" then return controls.press("right") end

if accion == "l" then return controls.press("l") end
if accion == "r" then return controls.press("r") end

if control.config[accion] == nil then
	return false
end

return controls.press(control.config[accion])
end

function control.old(accion,unlockeable) --- Devielve true o false si se esta presionando el boton pasado como argumento

if unlockeable ~= true then
	if control.checKey() == false then
		return false
	end
end

if accion == "up" then return controls.up() end
if accion == "down" then return controls.down() end
if accion == "left" then return controls.left() end
if accion == "right" then return controls.right() end

if accion == "l" then return controls.l() end
if accion == "r" then return controls.r() end

if control.config[accion] == nil then
	return false
end

	if control.config[accion] == "cross" then
		return controls.cross()
	end
	
	if control.config[accion] == "circle" then
		return controls.circle()
	end
	
	if control.config[accion] == "triangle" then
		return controls.triangle()
	end
	
	if control.config[accion] == "square" then
		return controls.square()
	end
	
return false

end

function control.relase(accion,llave) --- Devielve true o false si se solt el boton pasado como argumento
-- acciones: select scroll menu back home
if control.checKey() == false then return false end

if accion == "up" then return controls.relase("up") end
if accion == "down" then return controls.relase("down") end
if accion == "left" then return controls.relase("left") end
if accion == "right" then return controls.relase("right") end

if accion == "l" then return controls.press("l") end
if accion == "r" then return controls.press("r") end

if control.config[accion] == nil then
	return false
end

return controls.release(control.config[accion])
end

function control.isRelease()

if control.checKey() == false then return false end

if controls_seleccionar == "cross" then
return controls.cross()
end

if controls_seleccionar == "circle" then
return  controls.circle()
end

if controls_seleccionar == "square" then
return controls.square()
end

return false
end

function control.leerConfiguracion() --- Lee la configuracion de los controles de cada usuario
	--- Pendiente leer la configuracion de cada usuario, solo lee configuraciones globales
	dofile("ms0:/FISHELL/CFG/controls.ini")
	control.config["select"] = controls_seleccionar
	control.config["scroll"] = controls_scroll
	control.config["menu"] = controls_menu
	control.config["back"] = controls_retroceder
	control.config["home"] = controls_home
end

function control.lock(llave)
control.lock_llave = llave
end

function control.unlock()
control.lock_llave = nil
end

control.leerConfiguracion()

-------------------------------


-------------------------------
--[[ manejo de los sonidos ]]--
-------------------------------

function sonido.play(index) -- Reproduce el sonido con el indice de la lista
	if #sonido.list == 0 then return end
	
	if index ~= nil then
		if index <= 0 or index > #sonido.list then return end
	end
	
	if index == nil then
		if sonido.obj ~= nil and sonido.focus ~= 0 and  sonido.list[sonido.focus] ~= nil then
			sonido.playing = true
			sonido.obj:pause()
			
			if sonido.obj:playing() == false then
				sonido.obj:play()
				sonido.porcent = 0
			end
			
			return
		end
	end
	
	if sonido.focus ~= index then
		if sonido.list[index] ~= nil then
		
			if sonido.obj ~= nil then
				sonido.obj:free()
			end
			
			sonido.obj = sound.load(sonido.list[index].ruta)
			sonido.obj:play(3)
			sonido.playing = true
			sonido.focus = index
			sonido.porcent = 0
		end
	end
end

function sonido.pause() -- Pausa el sonido en reproduccion
	sonido.playing = false
	
	if sonido.obj ~= nil then
		sonido.obj:pause()
	end
end

function sonido.addList(ruta) -- aade un archivo de sonido a la lista
	if files.ext(ruta) == "mp3" or files.ext(ruta) == "ocg" or files.ext(ruta) == "wav" or files.ext(ruta) == "at3" then else return end
	if files.exists(ruta) == false then return end
	
	local nombre = files.nopath(ruta)
	local nombre = string.sub(nombre,0,#nombre - 4)
	
	local val = { ruta = ruta , nombre = nombre }
	
	val.extencion = files.ext(ruta)
	
	table.insert(sonido.list,val)
end

function sonido.runDrive() -- Corre el drive de sonido en listas de reproduccion
	if sonido.focus == 0 then return end
	
	if sonido.obj ~= nil and sonido.list[sonido.focus].extencion == "mp3" then
		sonido.porcent = sound.percent(sonido.obj)
	end
	
	if sonido.obj ~= nil and sonido.obj:playing() == false then
		sonido.playing = false
	end
	
	if sonido.porcent == 100 then
		sonido.playing = false
	end
	
	if sonido.playing == false and sonido.porcent >= 99 then
		if sonido.focus < #sonido.list then
			system.printLabel("06","Cargando pista")
			sonido.play(sonido.focus + 1)
			system.closeLabel()
		else
			-- codigo del loop
		end
	end
end

function sonido.reset()
	
	sonido.list = {}
	
	if sonido.obj ~= nil then
		sonido.obj:pause()
		sonido.obj:free()
		sonido.obj = nil
	end
	
	sonido.focus = 0
	sonido.playing = false
end

function sonido.getPlayName() --- Obtiene el nombre del archivo reproducido actualmente
	if sonido.focus == 0 and sonido.obj == nil then
		return
	end
	
	return sonido.list[sonido.focus].nombre
end

function sonido.freeAll() --- libera la lista
	sonido.list = nil
	sonido.list = {}
	
	sonido.focus = 0
	sonido.playing = false
	
	if sonido.obj ~= nil then
		sonido.obj:pause()
		sonido.obj:free()
		sonido.obj = nil
	end
	
	collectgarbage()
end